Package: r2rtf
Title: Easily Create Production-Ready Rich Text Format (RTF) Table and
        Figure
Version: 1.1.1
Authors@R: c(
    person("Yilong", "Zhang", role = "aut"),
    person("Siruo", "Wang", role = "aut"),
    person("Simiao", "Ye", role = "aut"),
    person("Fansen", "Kong", role = "aut"),
    person("Brian", "Lang", role = "aut"),
    person("Benjamin", "Wang", , email = "benjamin.wang@merck.com", role = c("aut", "cre")),
    person("Nan", "Xiao", role = "ctb"),
    person("Madhusudhan", "Ginnaram", role = "ctb"),
    person("Ruchitbhai", "Patel", role = "ctb"),
    person("Huei-Ling", "Chen", role = "ctb"),
    person("Peikun", "Wu", role = "ctb"),
    person("Uday Preetham", "Palukuru", role = "ctb"),
    person("Daniel", "Woodie", role = "ctb"),
    person("Sarad", "Nepal", role = "ctb"),
    person("Jane", "Liao", role = "ctb"),
    person("Jeff", "Cheng", role = "ctb"),
    person("Yirong", "Cao", role = "ctb"),
    person("Amin", "Shirazi", role = "ctb"),
    person("Merck Sharp & Dohme Corp", role = "cph")
    )
Description: Create production-ready Rich Text Format (RTF) table and figure
    with flexible format.
License: GPL-3
URL: https://merck.github.io/r2rtf/, https://github.com/Merck/r2rtf
BugReports: https://github.com/Merck/r2rtf/issues
Encoding: UTF-8
VignetteBuilder: knitr
LazyData: true
Depends: R (>= 3.5.0)
Imports: grDevices, tools
Suggests: covr, dplyr, emmeans, ggplot2, knitr, magrittr, officer,
        rmarkdown, stringi, testthat, tidyr, xml2
Config/testthat/edition: 3
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2023-10-24 22:44:25 UTC; wangben
Author: Yilong Zhang [aut],
  Siruo Wang [aut],
  Simiao Ye [aut],
  Fansen Kong [aut],
  Brian Lang [aut],
  Benjamin Wang [aut, cre],
  Nan Xiao [ctb],
  Madhusudhan Ginnaram [ctb],
  Ruchitbhai Patel [ctb],
  Huei-Ling Chen [ctb],
  Peikun Wu [ctb],
  Uday Preetham Palukuru [ctb],
  Daniel Woodie [ctb],
  Sarad Nepal [ctb],
  Jane Liao [ctb],
  Jeff Cheng [ctb],
  Yirong Cao [ctb],
  Amin Shirazi [ctb],
  Merck Sharp & Dohme Corp [cph]
Maintainer: Benjamin Wang <benjamin.wang@merck.com>
Repository: CRAN
Date/Publication: 2023-10-25 08:00:02 UTC
Built: R 4.4.0; ; 2024-04-29 00:06:32 UTC; unix

## ---- eval = FALSE------------------------------------------------------------
#  library(dplyr)
#  library(r2rtf)
#  
#  head(iris) %>%
#    rtf_body() %>% # Step 1 Add attributes
#    rtf_encode() %>% # Step 2 Convert attributes to RTF encode
#    write_rtf(file = "ex-tbl.rtf") # Step 3 Write to a .rtf file

test_that("multiplication works", {
  x <- c(
    "Greek: \\alpha\\beta\\gamma",
    "Symbole: \\dagger\\ddagger",
    "superscript: LS Mean^\\dagger",
    "superscript: LS Mean ^{\\dagger\\dagger}",
    "subscript:, HAMD_{17}",
    "superscript and subscript:, x_2^5"
  )

  x_utf8 <- c(
    "Greek: \\uc1\\u945*\\uc1\\u946*\\uc1\\u947*",
    "Symbole: \\uc1\\u8224*\\uc1\\u8225*",
    "superscript: LS Mean\\super \\uc1\\u8224*",
    "superscript: LS Mean \\super {\\uc1\\u8224*\\uc1\\u8224*}",
    "subscript:, HAMD\\sub {17}",
    "superscript and subscript:, x\\sub 2\\super 5"
  )

  expect_equal(convert(x), x_utf8)
  expect_equal(convert(x, load_stringi = TRUE), x_utf8)
  expect_equal(convert(x, load_stringi = FALSE), x_utf8)
})

test_that("margin type: csr, portrait", {
  expect_equal(
    set_margin("csr", "portrait"),
    c(1.25, 1.00, 1.50, 1.00, 0.50, 0.50)
  )
})

test_that("margin type: csr, landscape", {
  expect_equal(set_margin("csr", "landscape"),
    c(0.500000, 0.500000, 1.279861, 1.250000, 1.250000, 1.000000),
    tolerance = 0.00001
  )
})

test_that("margin type: wma, portrait", {
  expect_equal(
    set_margin("wma", "portrait"),
    c(1.25000, 1.00000, 1.75000, 1.25000, 1.75000, 1.00625)
  )
})

test_that("margin type: wma, landscape", {
  expect_equal(
    set_margin("wma", "landscape"),
    c(1.00, 1.00, 2.00, 1.25, 1.25, 1.25)
  )
})

test_that("margin type: wmm, portrait", {
  expect_equal(
    set_margin("wmm", "portrait"),
    c(1.25000, 1.00000, 1.00000, 1.00000, 1.75000, 1.00625)
  )
})

test_that("margin type: wmm, landscape", {
  expect_equal(
    set_margin("wmm", "landscape"),
    c(0.50, 0.50, 1.25, 1.00, 1.25, 1.25)
  )
})

test_that("margin type: narrow, portrait", {
  expect_equal(
    set_margin("narrow", "portrait"),
    c(0.5, 0.5, 0.5, 0.5, 0.5, 0.5)
  )
})

test_that("margin type: narrow, landscape", {
  expect_equal(
    set_margin("narrow", "landscape"),
    c(0.5, 0.5, 0.5, 0.5, 0.5, 0.5)
  )
})

test_that("doctype not in value list", {
  expect_error(set_margin("csR", "landscape"))
})

test_that("orientation not in value list", {
  expect_error(set_margin("csr", "landscapes"))
})

# Build Temporary dataset for use in testing
testdat <- iris[1:5, ]

# Check Temporary dataset attributes
testdatatt <- attributes(testdat)
testdat <- rtf_body(testdat,
  border_left = "single",
  border_right = "double",
  border_top = "double",
  border_bottom = "dot",
  border_color_left = "black",
  border_color_right = "red",
  border_color_top = "green",
  border_color_bottom = "gold",
  border_width = 1440,
  text_font = 2,
  text_format = "iub",
  text_color = "greenyellow",
  text_justification = "l",
  text_font_size = 12,
  text_space_before = 10,
  text_space_after = 10,
  text_background_color = "lightgoldenrod",
  text_convert = matrix(TRUE, nrow(testdat), ncol(testdat)),
  cell_justification = "r",
  col_rel_width = c(1, 2, 3, 4, 5),
  cell_height = 2
)

# Encode Temporary dataset
testdat2 <- rtf_table_content(
  tbl = testdat,
  use_border_bottom = TRUE
)

test_that("RTF table content generation", {
  # Check cell text font type encoding
  expect_snapshot_output(testdat2)
})

df <- c("fig/fig1.png", "fig/fig2.png")
df <- df |> rtf_read_figure()

df1 <- df |> rtf_figure() # to test default values

# to check multiple values
df2 <- df |> rtf_figure(fig_width = c(4.5, 6.2), fig_height = c(5.5, 6.1))

test_that("figure width and height attributes", {
  # check default values
  expect_true(is.matrix(attr(df1, "fig_width")))
  expect_true(is.matrix(attr(df1, "fig_height")))
  expect_equal(attr(df1, "fig_width"), matrix(c(5, 5), nrow = 2, ncol = 1))
  expect_equal(attr(df1, "fig_height"), matrix(c(5, 5), nrow = 2, ncol = 1))


  # check with non-default values
  expect_equal(attr(df2, "fig_width"), matrix(c(4.5, 6.2), nrow = 2, ncol = 1))
  expect_equal(attr(df2, "fig_height"), matrix(c(5.5, 6.1), nrow = 2, ncol = 1))
  expect_error(df |> rtf_figure(fig_width = c(-4, 6.2)))
  expect_error(df |> rtf_figure(fig_height = c(-4, -6)))
})

test_that("test update_border_first when attr(tbl, 'rtf_colheader') is not NULL", {
  tbl <- iris[1:2, ] |>
    rtf_page(border_color_first = "red") |>
    rtf_body() |>
    update_border_first()

  expect_equal(attributes(attr(tbl, "rtf_colheader")[[1]])$border_top, matrix("double", nrow = 1, ncol = 5))
  expect_equal(attributes(attr(tbl, "rtf_colheader")[[1]])$border_color_top, matrix("red", nrow = 1, ncol = 5))
})


test_that("test update_border_first when attr(tbl, 'rtf_colheader') is NULL", {
  tbl <- iris[c(1:2, 51:52), ] |>
    rtf_page(border_color_first = "red") |>
    rtf_body(
      page_by = "Species",
      new_page = TRUE
    )
  attr(tbl, "rtf_colheader") <- NULL
  tbl <- update_border_first(tbl)

  expect_equal(attributes(tbl)$border_first[1, ], c(rep("double", 5)))
  expect_equal(attributes(tbl)$border_color_first[1, ], rep("red", 5))
  expect_equal(attributes(attr(tbl, "rtf_pageby_table"))$border_first[1, ], c(rep("double", 4)))
  expect_equal(attributes(attr(tbl, "rtf_pageby_table"))$border_color_first[1, ], rep("red", 4))
})


test_that("test update_border_last when 'footnote' as_table", {
  tbl <- iris[1:2, ] |>
    rtf_page(
      border_color_first = "red",
      border_color_last = "red"
    ) |>
    rtf_body() |>
    rtf_footnote("footnote",
      as_table = TRUE
    )

  tbl <- update_border_last(tbl)

  expect_equal(attributes(attr(tbl, "rtf_footnote"))$border_bottom, "double")
  expect_equal(attributes(attr(tbl, "rtf_footnote"))$border_color_bottom, "red")
})


test_that("test update_border_last when 'source' as_table", {
  tbl <- iris[1:2, ] |>
    rtf_page(
      border_color_first = "red",
      border_color_last = "red"
    ) |>
    rtf_body() |>
    rtf_source("source",
      as_table = TRUE
    )

  tbl <- update_border_last(tbl)

  expect_equal(attributes(attr(tbl, "rtf_source"))$border_bottom, "double")
  expect_equal(attributes(attr(tbl, "rtf_source"))$border_color_bottom, "red")
})


test_that("test update_border_last when body as last", {
  tbl <- iris[c(1:2, 51:52), ] |>
    rtf_page(
      border_color_first = "red",
      border_color_last = "red"
    ) |>
    rtf_body(
      page_by = "Species",
      new_page = TRUE
    )

  tbl <- update_border_last(tbl)

  expect_equal(attributes(tbl)$border_last[nrow(tbl), ], c(rep("double", 5)))
  expect_equal(attributes(tbl)$border_color_last[nrow(tbl), ], rep("red", 5))
  expect_equal(attributes(attr(tbl, "rtf_pageby_table"))$border_last[nrow(attr(tbl, "rtf_pageby_table")), ], c(rep("double", 4)))
  expect_equal(attributes(attr(tbl, "rtf_pageby_table"))$border_color_last[nrow(attr(tbl, "rtf_pageby_table")), ], rep("red", 4))
})

library(dplyr)
svg(tempfile("tmp.svg"))
test_that("Test for case when output has title, footnote and source", {
  x <- iris[1:2, ] |>
    rtf_title("Title") |>
    rtf_footnote("Footnote") |>
    rtf_source("DataSource") |>
    rtf_body() |>
    rtf_pageby(page_by = "Species", new_page = TRUE, pageby_header = TRUE) |>
    as_rtf_pageby()

  expect_snapshot_output(x)
})

test_that("Test the pageby rows are the last rows of a page", {
  x <- iris |>
    rtf_title("Title") |>
    rtf_footnote("Footnote") |>
    rtf_source("DataSource") |>
    rtf_body() |>
    rtf_pageby(page_by = "Species", new_page = TRUE, pageby_header = FALSE)

  y <- as.data.frame(attributes(as_rtf_pageby(x))) |>
    group_by(info.id) |>
    summarise_all(last) |>
    mutate(row = substr(as.character(info.page), 1, 1))

  z <- as.data.frame(table(x$Species)) |>
    mutate(cu = cumsum(Freq))
  z <- z |> mutate(cum = cu + as.numeric(rownames(z)))

  expect_equal(y$row, rownames(y))
  expect_equal(y$info.index, z$cum)
  expect_false(all(y$info.pageby))
})

test_that("Test if border type/color for first/last row are assigned correctly", {
  x <- iris |>
    rtf_body(
      border_first = c("single", "dash", "dot", "triple", ""),
      border_last = c("single", "dash", "dot", "triple", ""),
      border_color_top = c("black", "gold", "ivory", "blue", "white"),
      border_color_bottom = c("black", "gold", "ivory", "blue", "white"),
      border_color_first = c("azure", "gold", "ivory", "bisque", "white"),
      border_color_last = c("red", "gold", "ivory", "bisque", "white")
    ) |>
    rtf_pageby(page_by = "Species", new_page = TRUE, pageby_header = TRUE) |>
    as_rtf_pageby()

  attr(x, "info") <- NULL

  expect_snapshot_output(x[1])
})

test_that("Test if page_dict attribute is created for tbl", {
  x <- iris |>
    rtf_body() |>
    rtf_pageby(page_by = "Species", new_page = TRUE, pageby_header = FALSE)

  y <- as_rtf_pageby(x)

  expect_equal(names(attributes(y)), "info")
  if (interactive()) expect_snapshot_output(y)
})


test_that("Test for more than one page_by var", {
  x <- iris |>
    mutate(cat = rep(1:5, 30)) |>
    arrange(Species, cat) |>
    rtf_page(nrow = 5) |>
    rtf_body() |>
    rtf_pageby(page_by = c("Species", "cat"), new_page = TRUE, pageby_header = TRUE)

  y <- as_rtf_pageby(x)
  expect_equal(names(attributes(y)), c("names", "info"))
  if (interactive()) expect_snapshot_output(y)
})


test_that("Test if new_page is FALSE and group_by is NOT NULL", {
  iris1 <- iris
  iris1$cat <- iris1$Species
  x <- iris1 |>
    rtf_body(group_by = "cat") |>
    rtf_pageby(page_by = "Species", new_page = FALSE, pageby_header = FALSE)
  y <- as_rtf_pageby(x)

  expect_equal(names(attributes(y)), "info")

  if (interactive()) expect_snapshot_output(y)
})

test_that("Test whether lines with '-----' were removed correctly", {
  x <- distinct(iris |> subset(Species != "virginica"), Species, .keep_all = T) |>
    mutate(Species = ifelse(Species == "setosa", "-----", Species)) |>
    rtf_colheader("Sepal.Length | Sepal.Width | Petal.Length | Petal.Width",
      col_rel_width = rep(1, 4)
    ) |>
    rtf_body(
      page_by = "Species",
      text_justification = c(rep("c", 4), "l"),
      border_top = c(rep("", 4), "single"),
      border_bottom = c(rep("", 4), "single")
    ) |>
    rtf_encode()

  expect_snapshot_output(x$body)
})


test_that("Test when using subline_by and page_by together in rtf_body", {
  tbl1 <- iris[c(1:4, 51:54), 3:5] |>
    mutate(s2 = paste0(Species, 1:2), s3 = s2) |>
    arrange(Species, s2) |>
    rtf_body(
      subline_by = "s2",
      page_by = "Species"
    ) |>
    rtf_encode()

  expect_snapshot_output(tbl1$body)
})


test_that("Test when using subline_by and page_by with pageby_row = 'first_row' in rtf_body", {
  tbl2 <- iris[c(1:4, 51:54), 3:5] |>
    mutate(s2 = paste0(Species, 1:2), s3 = s2) |>
    arrange(Species, s2) |>
    rtf_body(
      subline_by = "s2",
      page_by = "Species",
      pageby_row = "first_row"
    ) |>
    rtf_encode()

  expect_snapshot_output(tbl2$body)
})

dev.off()

test_that("RTF init", {
  expect_equal(
    as_rtf_init(),
    "{\\rtf1\\ansi\n\\deff0\\deflang1033"
  )
})

test_that("RTF font type encode", {
  expect_snapshot_output(as_rtf_font())
})

test_that("RTF font color encode with color not NULL", {
  x <- iris |>
    rtf_page(orientation = "portrait") |>
    rtf_body(text_color = "red")
  expect_snapshot_output(as_rtf_color(x))
})

test_that("RTF font color encode with color NULL", {
  x <- iris |> rtf_body()
  expect_equal(
    as_rtf_color(x),
    NULL
  )
})

test_that("RTF page width encode", {
  x <- iris |> rtf_page(orientation = "portrait", width = 8.5)
  expect_equal(as_rtf_page(x), "\\paperw12240\\paperh15840\n")
})

test_that("RTF page height encode - 11 inch", {
  x <- iris |> rtf_page(orientation = "portrait", height = 11)
  expect_equal(
    as_rtf_page(x),
    "\\paperw12240\\paperh15840\n"
  )
})


test_that("RTF page height encode - 10 inch", {
  x <- iris |> rtf_page(orientation = "portrait", height = 10)
  expect_equal(
    as_rtf_page(x),
    "\\paperw12240\\paperh14400\n"
  )
})

test_that("RTF page orientation encode - landscape", {
  x <- iris |> rtf_page(orientation = "landscape")
  expect_equal(
    as_rtf_page(x),
    "\\paperw15840\\paperh12240\\landscape\n"
  )
})

test_that("RTF page orientation encode - landscape + height 4 + width 6", {
  x <- iris |> rtf_page(orientation = "landscape", width = 6, height = 4)
  expect_equal(
    as_rtf_page(x),
    "\\paperw8640\\paperh5760\\landscape\n"
  )
})

test_that("RTF page margin encode", {
  x <- iris |> rtf_page(orientation = "portrait")
  expect_equal(
    as_rtf_margin(x),
    "\\margl1800\\margr1440\\margt2520\\margb1800\\headery2520\\footery1449\n"
  )
})

test_that("RTF page margin encode - landscape + height 4 + width 6", {
  x <- iris |> rtf_page(orientation = "landscape", width = 6, height = 4)
  expect_equal(
    as_rtf_margin(x),
    "\\margl1440\\margr1440\\margt2880\\margb1800\\headery1800\\footery1800\n"
  )
})

test_that("RTF title ", {
  x <- iris |> rtf_title(title = "title test")
  expect_snapshot_output(as_rtf_title(x))
})

test_that("RTF title when no attr assigned", {
  x <- iris
  expect_equal(as_rtf_title(x), NULL)
})


test_that("RTF colheader ", {
  x <- iris |> rtf_colheader()
  expect_equal(as_rtf_colheader(x), NULL)
})

test_that("RTF footnote font encode - font 2", {
  x <- iris |> rtf_footnote(footnote = "test", text_font = 2)
  expect_equal(as_rtf_footnote(x), "\\trowd\\trgaph108\\trleft0\\trqc\n\\clbrdrl\\brdrs\\brdrw15\\clbrdrt\\brdrw15\\clbrdrr\\brdrs\\brdrw15\\clbrdrb\\brdrs\\brdrw15\\clvertalt\\cellx9000\n\\pard\\hyphpar0\\sb15\\sa15\\fi0\\li0\\ri0\\ql\\fs18{\\f1 test}\\cell\n\\intbl\\row\\pard")
})

test_that("RTF footnote font encode - font 3", {
  x <- iris |> rtf_footnote(footnote = "test", text_font = 3)
  expect_equal(as_rtf_footnote(x), "\\trowd\\trgaph108\\trleft0\\trqc\n\\clbrdrl\\brdrs\\brdrw15\\clbrdrt\\brdrw15\\clbrdrr\\brdrs\\brdrw15\\clbrdrb\\brdrs\\brdrw15\\clvertalt\\cellx9000\n\\pard\\hyphpar0\\sb15\\sa15\\fi0\\li0\\ri0\\ql\\fs18{\\f2 test}\\cell\n\\intbl\\row\\pard")
})


test_that("RTF footnote format, size and color encode", {
  x <- iris |> rtf_footnote(footnote = "test", text_font_size = 8, text_format = "i", text_color = "red")
  expect_equal(as_rtf_footnote(x), "\\trowd\\trgaph108\\trleft0\\trqc\n\\clbrdrl\\brdrs\\brdrw15\\clbrdrt\\brdrw15\\clbrdrr\\brdrs\\brdrw15\\clbrdrb\\brdrs\\brdrw15\\clvertalt\\cellx9000\n\\pard\\hyphpar0\\sb15\\sa15\\fi0\\li0\\ri0\\ql\\fs16{\\f0\\i\\cf552 test}\\cell\n\\intbl\\row\\pard")
})

test_that("RTF footnote NULL", {
  x <- iris
  expect_equal(as_rtf_footnote(x), NULL)
})

test_that("RTF footnote when as_table = TRUE", {
  x <- iris |> rtf_footnote(footnote = "test", as_table = TRUE)
  expect_equal(as_rtf_footnote(x), "\\trowd\\trgaph108\\trleft0\\trqc\n\\clbrdrl\\brdrs\\brdrw15\\clbrdrt\\brdrw15\\clbrdrr\\brdrs\\brdrw15\\clbrdrb\\brdrs\\brdrw15\\clvertalt\\cellx9000\n\\pard\\hyphpar0\\sb15\\sa15\\fi0\\li0\\ri0\\ql\\fs18{\\f0 test}\\cell\n\\intbl\\row\\pard")
})

test_that("RTF footnote when as_table = FALSE", {
  x <- iris |>
    rtf_body() |>
    rtf_footnote(footnote = "test", as_table = FALSE)
  expect_snapshot_output(as_rtf_footnote(x))
})

test_that("RTF source font encode", {
  x <- iris |> rtf_source("data source: adae", text_font = 2)
  expect_snapshot_output(as_rtf_source(x))
})

test_that("RTF source format, size and color encode", {
  x <- iris |> rtf_source("data source: adae", text_font_size = 8, text_format = "b", text_color = "red")
  expect_snapshot_output(as_rtf_source(x))
})

test_that("RTF source NULL", {
  x <- iris
  expect_equal(as_rtf_source(x), NULL)
})

test_that("RTF source when as_table = TRUE", {
  x <- iris |> rtf_source(source = "test", as_table = TRUE)
  expect_snapshot_output(as_rtf_source(x))
})

test_that("RTF source when as_table = FALSE", {
  x <- iris |> rtf_source(source = "test", as_table = FALSE)
  expect_snapshot_output(as_rtf_source(x))
})

test_that("RTF new page", {
  expect_snapshot_output(as_rtf_new_page())
})

test_that("RTF end", {
  expect_equal(
    as_rtf_end(),
    "}"
  )
})


# tests not using as_rtf_source
test_that("RTF page width encode", {
  x <- iris |> rtf_page(orientation = "portrait", width = 8.5)
  expect_equal(attr(x, "page")$width, 8.5)
  expect_equal(attr(x, "page")$orientation, "portrait")
})


test_that("RTF page margin encode - landscape + height 4 + width 6", {
  x <- iris |> rtf_page(orientation = "landscape", width = 6, height = 4)
  expect_equal(attr(x, "page")$width, 6)
  expect_equal(attr(x, "page")$height, 4)
  expect_equal(attr(x, "page")$orientation, "landscape")
})

# add tests for new features
test_that("Test for function as_rtf_page() when page header exists", {
  x <- head(iris, 2) |>
    rtf_page_header(text = "header test text")

  expect_equal(as_rtf_page(x), "{\\header\n{\\pard\\sb15\\sa15\\fi0\\li0\\ri0\\qr\\fs24{\\f0 header test text}\\par}\n}\n\\paperw12240\\paperh15840\n")
})

test_that("Test for function as_rtf_page() when page footer exists", {
  ft <- head(iris, 2) |>
    rtf_page_footer(text = "footer test text")

  expect_equal(as_rtf_page(ft), "{\\footer\n{\\pard\\sb15\\sa15\\fi0\\li0\\ri0\\qc\\fs24{\\f0 footer test text}\\par}\n}\n\\paperw12240\\paperh15840\n")
})

test_that("Test for function as_rtf_subline() when subline exists", {
  sl <- head(iris, 2) |>
    rtf_subline(text = "subline test text")

  expect_equal(as_rtf_subline(sl), "{\\pard\\hyphpar\\sb180\\sa180\\fi0\\li0\\ri0\\ql\\fs24{\\f0 subline test text}\\par}")
})

# test_that("Test for function as_rtf_footnote() when there is no text conversion
# i.e. attr(text, 'text_convert') = NULL", {
#   fn1 <- head(iris, 2) |>
#     rtf_title(title = 'footnote example') |>
#     rtf_footnote(footnote = c("> = sign: {\\geq}", "superscript: {^a}"),
#                  text_convert=FALSE)
#
#   expect_true(grepl("\\geq", as_rtf_footnote(fn1), fixed = TRUE))
#   expect_true(grepl("^a", as_rtf_footnote(fn1), fixed = TRUE))
#
#   fn2 <- head(iris, 2) |>
#     rtf_title(title = 'footnote example') |>
#     rtf_footnote(footnote = c("> = sign: {\\geq}", "superscript: {^a}"))
#
#   expect_false(grepl("\\geq", as_rtf_footnote(fn2), fixed = TRUE))
#   expect_false(grepl("^a", as_rtf_footnote(fn2), fixed = TRUE))
# })
#
# test_that("Test for function as_rtf_source() when there is no text conversion
# i.e. attr(text, 'text_convert') = NULL", {
#   sc <- head(iris, 2) |>
#     rtf_source(source = c(">= sign: {\\geq}", "superscript: {^a}"),
#                text_convert = FALSE)
#
#   expect_true(grepl("\\geq", as_rtf_source(sc), fixed = TRUE))
#   expect_true(grepl("^a", as_rtf_source(sc), fixed = TRUE))
# })

test_that("Case when arg input is NULL", {
  # Check when arg input is NULL
  expect_identical(check_args(NULL), NULL)
})

test_that("Case when type input is not NULL", {
  # Check when arg is character vector
  expect_identical(check_args(c("a", "b", "c"), type = c("character")), NULL)

  # Check when arg is numeric vector
  expect_identical(check_args(c(1, 2, 3), type = c("numeric")), NULL)

  # Check when arg is integer vector
  expect_identical(check_args(c(1L, 2L, 3L), type = c("integer")), NULL)

  # Check when arg is character matrix
  expect_identical(
    check_args(matrix(c("a", "b", "c", "d"), nrow = 2, ncol = 2),
      type = c("character")
    ),
    NULL
  )

  # Check when arg is integer matrix
  expect_identical(
    check_args(matrix(1:9, nrow = 3, ncol = 3),
      type = c("integer")
    ),
    NULL
  )

  # Check when arg is data frame
  expect_identical(
    check_args(iris[1:10, ],
      type = c("data.frame")
    ),
    NULL
  )
})

test_that("Case when length input is not NULL", {
  # Check when arg is character vector
  expect_identical(
    check_args(c("a", "b", "c"),
      type = c("character"),
      length = 3
    ),
    NULL
  )

  # Check when arg is numeric vector
  expect_identical(
    check_args(c(1, 2, 3, 4, 5),
      type = c("numeric"),
      length = 5
    ),
    NULL
  )

  # Check when arg is integer vector
  expect_identical(
    check_args(c(1L, 2L),
      type = c("integer"),
      length = 2
    ),
    NULL
  )

  # Check when arg is character matrix
  expect_identical(
    check_args(matrix(c("a", "b", "c", "d"), nrow = 2, ncol = 2),
      type = c("character"),
      length = 4
    ),
    NULL
  )

  # Check when arg is integer matrix
  expect_identical(
    check_args(matrix(1:9, nrow = 3, ncol = 3),
      type = c("integer"),
      length = 9
    ),
    NULL
  )

  # Check when arg is data frame
  expect_identical(
    check_args(iris[1:10, 1:2],
      type = c("data.frame"),
      length = 2
    ),
    NULL
  )
})

test_that("Case when dim input is not NULL", {
  # Check when arg is data frame
  expect_identical(
    check_args(iris[1:10, 1:2],
      type = c("data.frame"),
      dim = c(10, 2)
    ),
    NULL
  )
})

test_that("Test if correct message note is provided for differenct cases", {
  # Check when no input is given
  expect_error(
    check_args(),
    'argument "arg" is missing, with no default'
  )

  # Check when arg and type do not match
  expect_error(
    check_args(c(1, 2, 3), type = c("character")),
    "The argument type did not match: character"
  )

  # Check when arg length and length input do not match
  expect_error(
    check_args(c(1, 2, 3),
      type = c("numeric"),
      length = 2
    ),
    "The argument length is not 2"
  )

  # Check when arg dimensions and dim input do not match
  expect_error(
    check_args(iris[1:10, 1:2],
      type = c("data.frame"),
      dim = c(1, 2)
    ),
    "The argument dimension is not 1,2"
  )
})

tbl.p <- head(iris) |>
  rtf_footnote(text_indent_left = 1) |>
  rtf_page(orientation = "portrait")
tbl.l <- head(iris) |>
  rtf_footnote(text_indent_left = 1) |>
  rtf_page(orientation = "landscape")

test_that("space adjust when orientation is portrait", {
  adj.space.p <- round((round(attr(tbl.p, "page")$width * 1440)
  - round(attr(tbl.p, "page")$margin[1] * 1440)
    - round(attr(tbl.p, "page")$margin[2] * 1440)
    - round(attr(tbl.p, "page")$col_width * 1440)) / 2)
  expect_equal(footnote_source_space(tbl.p), adj.space.p)
})

test_that("space adjust when orientation is landscape", {
  adj.space.l <- round((round(attr(tbl.l, "page")$width * 1440)
  - round(attr(tbl.l, "page")$margin[1] * 1440)
    - round(attr(tbl.l, "page")$margin[2] * 1440)
    - round(attr(tbl.l, "page")$col_width * 1440)) / 2)
  expect_equal(footnote_source_space(tbl.l), adj.space.l)
})

test_that("test when text_indent_reference is page_margin", {
  expect_equal(footnote_source_space(tbl.l, text_indent_reference = "page_margin"), 0)
})

test_that("Case when colheader equals to NULL", {
  x <- iris |> rtf_colheader(colheader = "")
  expect_null(as_rtf_colheader(x))

  x <- iris |> rtf_colheader(colheader = "", border_color_left = "red")
  expect_null(as_rtf_colheader(x))
})

test_that("Case when colheader is not NULL and border color is specified", {
  x <- iris |> rtf_colheader(colheader = "a | b| c", border_color_left = "green")
  expect_snapshot_output(as_rtf_colheader(x))

  x <- iris |> rtf_colheader(colheader = "a | b| c", border_color_left = "red", border_color_right = "red")
  expect_snapshot_output(as_rtf_colheader(x))
})

test_that("case when colheader is not NULL and border type is specified", {
  x <- iris |> rtf_colheader(colheader = "a | b| c", border_right = "double")
  expect_snapshot_output(as_rtf_colheader(x))

  x <- iris |> rtf_colheader(colheader = "a | b| c", border_top = "dot dash")
  expect_snapshot_output(as_rtf_colheader(x))
})

test_that("case when colheader is not NULL and cell text formats is specified", {
  x <- iris |> rtf_colheader(colheader = "a | b| c", text_format = "i")
  expect_snapshot_output(as_rtf_colheader(x))

  x <- iris |> rtf_colheader(colheader = "a | b| c", text_format = "b")
  expect_snapshot_output(as_rtf_colheader(x))
})

test_that("Write function test for simple text and dataset", {
  a <- "Just a random Text and Symbols.!@#$%^&*()[],:; \ <>"
  write_rtf(a, file = file.path(tempdir(), "tabel.rtf"))
  b <- paste(readLines(file.path(tempdir(), "tabel.rtf")), collapse = "\n")

  x <- head(iris) |>
    rtf_body() |>
    rtf_encode()
  write_rtf(x, file = file.path(tempdir(), "tabel.rtf"))
  y <- paste(readLines(file.path(tempdir(), "tabel.rtf")), collapse = "\n")

  expect_equal(paste(unlist(a), collapse = "\n"), b)
  expect_equal(paste(unlist(x), collapse = "\n"), y)
})

test_that("Write function test for simple text", {
  a <- "Just a random Text and Symbols.!@#$%^&*()[],:; \ <>"
  write_rtf_para(a, file = file.path(tempdir(), "tabel.rtf"))
  b <- paste(readLines(file.path(tempdir(), "tabel.rtf")), collapse = "\n")

  cl <- color_table()
  rt_cl <- paste(c("{\\colortbl\n;", cl$rtf_code, "}"), collapse = "\n")
  st_rt <- paste(as_rtf_init(), as_rtf_font(), rt_cl, sep = "\n")
  c <- paste(st_rt, "{\\pard \\par}", paste(a, collapse = ""), as_rtf_end(), sep = "\n")

  expect_equal(b, c)
})

test_that("Write function test for dataset input", {
  x <- head(iris) |>
    rtf_body() |>
    rtf_encode()
  write_rtf_para(x, file = file.path(tempdir(), "tabel.rtf"))
  y <- paste(readLines(file.path(tempdir(), "tabel.rtf")), collapse = "\n")

  cl <- color_table()
  rt_cl <- paste(c("{\\colortbl\n;", cl$rtf_code, "}"), collapse = "\n")
  st_rt <- paste(as_rtf_init(), as_rtf_font(), rt_cl, sep = "\n")
  z <- paste(st_rt, "{\\pard \\par}", paste(x, collapse = ""), as_rtf_end(), sep = "\n")

  expect_equal(y, z)
})

library(dplyr)

test_that("Test case when page_by is NULL and new_page is TRUE", {
  expect_error(iris[1:2, ] |>
    rtf_body() |>
    rtf_pageby(page_by = NULL, new_page = TRUE, pageby_header = TRUE))
})

test_that("Test case when page_by is not NULL and data is sorted by the page_by variable", {
  expect_output(str(iris[1:2, ] |>
    arrange(Petal.Length) |>
    rtf_body() |>
    rtf_pageby(
      page_by = c("Petal.Length"), new_page = TRUE,
      pageby_header = TRUE
    )), "2 obs")

  a <- iris[1:2, ] |>
    arrange(Sepal.Width) |>
    rtf_body() |>
    rtf_pageby(
      page_by = c("Sepal.Width"), new_page = TRUE,
      pageby_header = TRUE
    )
  expect_equal(attributes(a)$rtf_pageby$by_var, "Sepal.Width")
})

test_that("Test if page_by attributes are assigned correctly to tbl", {
  x <- iris[1:2, ] |>
    dplyr::arrange(Petal.Length) |>
    rtf_body() |>
    rtf_pageby(page_by = c("Petal.Length"), new_page = TRUE, pageby_header = TRUE)

  expect_true(attributes(x)$rtf_pageby$new_page)
  expect_equal(attributes(x)$rtf_pageby$by_var, "Petal.Length")
  expect_equal(attributes(x)$rtf_pageby$id, factor(x$Petal.Length))
  expect_true(attributes(x)$rtf_pageby$pageby_header)

  y <- iris[1:2, ] |>
    rtf_body() |>
    rtf_pageby(page_by = NULL, new_page = FALSE, pageby_header = TRUE)

  expect_false(attributes(y)$rtf_pageby$new_page)
  expect_equal(attributes(y)$rtf_pageby$by_var, NULL)
  expect_equal(attributes(y)$rtf_pageby$id, NULL)
})


test_that("Test if there are more than one page_by variables", {
  x <- iris[1:60, ] |>
    dplyr::arrange(Petal.Width, Petal.Length) |>
    rtf_body() |>
    rtf_pageby(page_by = c("Petal.Width", "Petal.Length"), new_page = TRUE, pageby_header = TRUE)

  expect_true(attributes(x)$rtf_pageby$new_page)
  expect_equal(attributes(x)$rtf_pageby$by_var, c("Petal.Width", "Petal.Length"))
  expect_true(attributes(x)$rtf_pageby$pageby_header)
})

# add tests for new features
test_that("Test case when pageby_row='first_row'", {
  x <- iris[c(1:4, 51:54), 3:5] |>
    mutate(s2 = paste0(Species, 1:2), s3 = s2) |>
    arrange(Species, s2) |>
    rtf_colheader("patelLength|patelWidth|s3") |>
    rtf_body(subline_by = "Species") |>
    rtf_pageby(
      page_by = "s2",
      pageby_row = "first_row"
    )

  expect_false(attributes(x)$rtf_pageby$new_page)
  expect_equal(attributes(x)$rtf_pageby$by_var, "s2")
  expect_true(attributes(x)$rtf_pageby$pageby_header)
  expect_equal(attributes(x)$rtf_pageby$pageby_row, "first_row")
})


test_that("Test case when subline is not NULL", {
  x <- iris[c(1:4, 51:54), 3:5] |>
    mutate(s2 = paste0(Species, 1:2), s3 = s2) |>
    arrange(Species, s2) |>
    rtf_colheader("patelLength|patelWidth|s3") |>
    rtf_body(subline_by = "Species") |>
    rtf_pageby(
      page_by = "s2",
      pageby_row = "first_row"
    )

  expect_equal(as.character(attributes(x)$rtf_by_subline_row$x), unique(x$Species))
  expect_equal(attributes(x)$rtf_by_subline$by_var, "Species")
  expect_equal(attributes(x)$rtf_by_subline$new_page, TRUE)
})

# tests using as_rtf_source
test_that("case when source equals to NULL", {
  x <- iris |>
    rtf_body() |>
    rtf_source()
  expect_snapshot_output(as_rtf_source(x))
})

test_that("source justification right and identation first 1, left 2", {
  x <- iris |>
    rtf_body() |>
    rtf_source(source = "testing", text_indent_first = 1, text_indent_left = 2, text_justification = "r")
  expect_snapshot_output(as_rtf_source(x))
})

test_that("source justification left and identation first 1, right 2", {
  x <- iris |>
    rtf_body() |>
    rtf_source(source = "testing", text_indent_first = 1, text_indent_right = 2, text_justification = "l")
  expect_snapshot_output(as_rtf_source(x))
})

test_that("source justification left and identation left 2", {
  x <- iris |>
    rtf_body() |>
    rtf_source(source = "testing", text_indent_left = 2, text_justification = "l")
  expect_snapshot_output(as_rtf_source(x))
})

test_that("source font=2, formats=bold", {
  x <- iris |>
    rtf_body() |>
    rtf_source(source = "testing", text_font = 2, text_format = "b")
  expect_snapshot_output(as_rtf_source(x))
})


# tests not using as_rtf_source
test_that("test case on source equals to NULL", {
  x <- iris |>
    rtf_body() |>
    rtf_source()
  expect_equal(attr(x, "rtf_source")[1], "")
})

test_that("test case on source justification right and identation first 1, left 2", {
  x <- iris |>
    rtf_body() |>
    rtf_source(source = "testing", text_indent_first = 1, text_indent_left = 2, text_justification = "r")
  expect_equal(attr(attr(x, "rtf_source"), "text_indent_first"), 1)
  expect_equal(attr(attr(x, "rtf_source"), "text_indent_left"), 2)
  expect_equal(attr(attr(x, "rtf_source"), "text_justification"), "r")
})

test_that("test case on source justification left and identation first 1, right 2", {
  x <- iris |>
    rtf_body() |>
    rtf_source(source = "testing", text_indent_first = 1, text_indent_right = 2, text_justification = "l")
  expect_equal(attr(attr(x, "rtf_source"), "text_indent_first"), 1)
  expect_equal(attr(attr(x, "rtf_source"), "text_indent_right"), 2)
  expect_equal(attr(attr(x, "rtf_source"), "text_justification"), "l")
})

test_that("test case on source justification left and identation left 2", {
  x <- iris |>
    rtf_body() |>
    rtf_source(source = "testing", text_indent_left = 2, text_justification = "l")
  expect_equal(attr(attr(x, "rtf_source"), "text_indent_left"), 2)
  expect_equal(attr(attr(x, "rtf_source"), "text_justification"), "l")
})


test_that("test case on source font=2, formats=bold ", {
  x <- iris |>
    rtf_body() |>
    rtf_source(source = "testing", text_font = 2, text_format = "b")
  expect_equal(attr(attr(x, "rtf_source"), "text_font"), 2)
  expect_equal(attr(attr(x, "rtf_source"), "text_format"), "b")
})

test_that("source justification right and identation right 2, and text_indent_reference is table/page_margin", {
  x <- iris |>
    rtf_page(width = 5.5, col_width = 3) |>
    rtf_body()
  x_table <- x |> rtf_source(
    source = "testing", text_indent_right = 2, text_justification = "r",
    text_indent_reference = "table"
  )
  expect_equal(attr(attr(x_table, "rtf_source"), "text_indent_right"), 2 + 180)

  x_page <- x |> rtf_source(
    source = "testing", text_indent_right = 2, text_justification = "r",
    text_indent_reference = "page_margin"
  )
  expect_equal(attr(attr(x_page, "rtf_source"), "text_indent_right"), 2 + 0)
})

test_that("text font", {
  expect_snapshot_output(font_type())
})

test_that("text color", {
  t_color <- data.frame(color = grDevices::colors())
  t_color$type <- 1:nrow(t_color)
  t_color <- cbind(t_color, t(grDevices::col2rgb(t_color$color)))
  t_color$rtf_code <- paste0("\\red", t_color$red, "\\green", t_color$green, "\\blue", t_color$blue, ";")

  expect_equal(color_table(), t_color)
})

test_that("text format", {
  t_format <- data.frame(
    type = c("", "b", "i", "u", "s", "^", "_"),
    name = c("normal", "bold", "italics", "underline", "strike", "superscript", "subscript"),
    rtf_code = c("", "\\b", "\\i", "\\ul", "\\strike", "\\super", "\\sub"),
    stringsAsFactors = FALSE
  )

  expect_equal(font_format(), t_format)
})

test_that("text justification", {
  t_just <- data.frame(
    type = c("l", "c", "r", "d", "j"),
    name = c("left", "center", "right", "decimal", "justified"),
    rtf_code_text = c("\\ql", "\\qc", "\\qr", "\\qj", "\\qj"),
    rtf_code_row = c("\\trql", "\\trqc", "\\trqr", "", ""),
    stringsAsFactors = FALSE
  )

  expect_equal(justification(), t_just)
})

test_that("border type", {
  expect_snapshot_output(border_type())
})


test_that("spacing", {
  spacing <- data.frame(
    type = c(1, 2, 1.5),
    name = c("single-space", "double-space", "1.5-space"),
    rtf_code = c("", "\\sl480\\slmult1", "\\sl360\\slmult1"),
    stringsAsFactors = FALSE
  )
  expect_equal(spacing(), spacing)
})

# Build Temporary dataset for use in testing
testdat <- iris[1:100, ]

# Check Temporary dataset attributes
testdatatt <- attributes(testdat)


test_that("case when as_colheader equals to NULL", {
  # Check case when as_colheader equals to ""

  expect_error(
    rtf_body(
      tbl = testdat,
      as_colheader = ""
    ),
    "The argument type did not match: logical"
  )

  # Check case when as_colheader equals to NULL

  expect_error(
    rtf_body(
      tbl = testdat,
      as_colheader = NULL
    ),
    "argument is of length zero"
  )
})

test_that("Column relative width", {
  # Check case when col_rel_width equals to ""

  expect_error(
    rtf_body(
      tbl = testdat,
      col_rel_width = ""
    ),
    "The argument type did not match: integer/numeric"
  )

  # Check col_rel_width attributes

  testdat2 <- testdat |>
    rtf_body(col_rel_width = c(1, 2, 3, 4, 5))

  expect_identical(
    attributes(testdat2)$col_rel_width,
    c(1, 2, 3, 4, 5)
  )
})

test_that("border type and color", {
  # Check border type and color attributes defaults

  testdat2 <- testdat |>
    rtf_body()

  expect_identical(
    attributes(testdat2)$border_left[50, 1:5],
    rep(c("single"), 5)
  )

  expect_identical(
    attributes(testdat2)$border_right[35, 1:5],
    rep(c("single"), 5)
  )

  expect_identical(
    attributes(testdat2)$border_top[1, 1:5],
    rep(c(""), 5)
  )

  expect_identical(
    attributes(testdat2)$border_bottom[100, 1:5],
    rep(c(""), 5)
  )

  expect_identical(
    attributes(testdat2)$border_first[1, 1:5],
    rep(c("single"), 5)
  )

  expect_identical(
    attributes(testdat2)$border_last[100, 1:5],
    rep(c("single"), 5)
  )

  expect_identical(
    attributes(testdat2)$border_color_left[50, 1:5],
    rep(c(NULL), 5)
  )

  expect_identical(
    attributes(testdat2)$border_color_right[35, 1:5],
    rep(c(NULL), 5)
  )

  expect_identical(
    attributes(testdat2)$border_color_top[1, 1:5],
    rep(c(NULL), 5)
  )

  expect_identical(
    attributes(testdat2)$border_color_bottom[100, 1:5],
    rep(c(NULL), 5)
  )

  expect_identical(
    attributes(testdat2)$border_color_first[1, 1:5],
    rep(c(NULL), 5)
  )

  expect_identical(
    attributes(testdat2)$border_color_last[100, 1:5],
    rep(c(NULL), 5)
  )

  # Check commonly used border type and color attributes formats

  testdat2 <- testdat |>
    rtf_body(
      border_left = c(
        "",
        "single",
        "double",
        "double",
        "dash"
      ),
      border_right = c(
        "dot",
        "dot dash",
        "double",
        "dash",
        "double"
      ),
      border_color_left = c(
        "white",
        "red",
        "blue",
        "green",
        "yellow"
      ),
      border_color_right = c(
        "brown",
        "violet",
        "bisque",
        "black",
        "cyan"
      ),
      border_color_top = c(
        "cadetblue",
        "darkblue",
        "violetred",
        "yellowgreen",
        "skyblue"
      ),
      border_color_bottom = c(
        "salmon",
        "sienna",
        "pink",
        "plum",
        "purple"
      ),
      border_color_first = c(
        "orange",
        "navy",
        "mintcream",
        "orchid",
        "magenta"
      ),
      border_color_last = c(
        "linen",
        "ivory",
        "khaki",
        "lavender",
        "indianred"
      )
    )

  expect_identical(
    attributes(testdat2)$border_color_left[50, 1:5],
    c("white", "red", "blue", "green", "yellow")
  )

  expect_identical(
    attributes(testdat2)$border_color_right[35, 1:5],
    c("brown", "violet", "bisque", "black", "cyan")
  )

  expect_identical(
    attributes(testdat2)$border_color_top[1, 1:5],
    c("cadetblue", "darkblue", "violetred", "yellowgreen", "skyblue")
  )

  expect_identical(
    attributes(testdat2)$border_color_bottom[100, 1:5],
    c("salmon", "sienna", "pink", "plum", "purple")
  )

  expect_identical(
    attributes(testdat2)$border_color_first[1, 1:5],
    c("orange", "navy", "mintcream", "orchid", "magenta")
  )

  expect_identical(
    attributes(testdat2)$border_color_last[100, 1:5],
    c("linen", "ivory", "khaki", "lavender", "indianred")
  )
})

test_that("cell justification and height", {
  # Check cell justification and height attribute default

  testdat2 <- testdat |>
    rtf_body()

  expect_identical(attributes(testdat2)$cell_justification, "c")

  expect_identical(attributes(testdat2)$cell_height, 0.15)

  testdat2 <- testdat[1:2, ] |>
    rtf_body(
      cell_justification = "j",
      cell_height = 2
    )

  expect_identical(attributes(testdat2)$cell_justification, "j")

  expect_identical(attributes(testdat2)$cell_height, 2)
})

test_that("text type", {
  # Check text attributes default

  testdat2 <- testdat |>
    rtf_body()

  expect_identical(attributes(testdat2)$text_justification[35, 1:5], rep(c("c"), 5))

  expect_identical(attributes(testdat2)$text_font[50, 1:5], rep(c(1), 5))

  expect_identical(attributes(testdat2)$text_font_size[100, 1:5], rep(c(9), 5))

  expect_null(attributes(testdat2)$text_format)

  expect_null(attributes(testdat2)$text_color)

  expect_null(attributes(testdat2)$text_background_color)

  expect_identical(attributes(testdat2)$text_space_before, 15)

  expect_identical(attributes(testdat2)$text_space_after, 15)


  testdat2 <- testdat[1:2, ] |>
    rtf_body(
      text_justification = c("l", "c", "r", "d", "j", "l", "c", "r", "d", "j"),
      text_font = c(1, 2, 3, 3, 2, 1, 2, 1, 3, 1),
      text_font_size = c(1, 2, 5, 10, 20, 30, 40, 50, 60, 100),
      text_format = c("", "b", "i", "u", "s", "ub", "ib", "sb", "^", ""),
      text_color = c(
        "white", "red", "blue", "green", "yellow",
        "cadetblue", "darkblue", "violetred",
        "yellowgreen", "skyblue"
      ),
      text_background_color = c(
        "salmon", "sienna", "pink", "plum",
        "purple", "orange", "navy", "mintcream",
        "orchid", "magenta"
      ),
      text_space_before = c(1, 2, 3, 10, 1.56, 7.23, 4.5, 6.986, 100, 3.23),
      text_space_after = c(3.25, 1.235, 1.852, 187, 38, 1.45, 2, 8, 100, 0.12)
    )

  expect_identical(
    attributes(testdat2)$text_justification[1, 1:5],
    c("l", "c", "r", "d", "j")
  )

  expect_identical(
    attributes(testdat2)$text_font[2, 1:5],
    c(1, 2, 1, 3, 1)
  )

  expect_identical(
    attributes(testdat2)$text_font_size[1, 1:5],
    c(1, 2, 5, 10, 20)
  )

  expect_identical(
    attributes(testdat2)$text_format[2, 1:5],
    c("ub", "ib", "sb", "^", "")
  )

  expect_identical(
    attributes(testdat2)$text_color[1, 1:5],
    c("white", "red", "blue", "green", "yellow")
  )

  expect_identical(
    attributes(testdat2)$text_background_color[2, 1:5],
    c("orange", "navy", "mintcream", "orchid", "magenta")
  )

  expect_identical(
    attributes(testdat2)$text_space_before[1:5],
    c(1, 2, 3, 10, 1.56)
  )

  expect_identical(
    attributes(testdat2)$text_space_after[6:10],
    c(1.45, 2, 8, 100, 0.12)
  )
})


test_that("Case for subline_by", {
  tbl <- iris[c(1:2, 51:52), ] |>
    rtf_body(
      subline_by = c("Species")
    )

  expect_identical(
    data.frame(attributes(tbl)$rtf_by_subline_row),
    data.frame(x = unique(tbl$Species))
  )

  expect_identical(
    attr(attr(tbl, "rtf_by_subline_row"), "border_top"),
    matrix("", nrow = 2, ncol = 1)
  )

  expect_identical(
    attributes(attr(tbl, "rtf_by_subline_row"))$border_bottom,
    matrix("", nrow = 2, ncol = 1)
  )
})


test_that("Case for page_by", {
  tbl0 <- iris[c(1:2, 51:52), ] |>
    rtf_body(
      page_by = c("Species")
    )

  expect_identical(
    data.frame(attributes(tbl0)$rtf_pageby_row),
    data.frame(x = unique(tbl0$Species))
  )
})


test_that("Case for using subline_by and page_by together", {
  tbl1 <- iris[c(1:4, 51:54), 3:5] |>
    mutate(s2 = paste0(Species, 1:2), s3 = s2) |>
    arrange(Species, s2) |>
    rtf_body(
      subline_by = "Species",
      page_by = "s2"
    )

  expect_identical(
    data.frame(attributes(tbl1)$rtf_by_subline_row),
    data.frame(x = unique(tbl1$Species))
  )

  expect_identical(
    data.frame(attributes(tbl1)$rtf_pageby_row),
    data.frame(x = unique(tbl1$s2))
  )

  expect_identical(
    attr(attr(tbl1, "rtf_by_subline_row"), "border_top"),
    matrix("", nrow = 2, ncol = 1)
  )

  expect_identical(
    attributes(attr(tbl1, "rtf_by_subline_row"))$border_bottom,
    matrix("", nrow = 2, ncol = 1)
  )
})

test_that("Case for using subline_by and page_by with pageby_row = 'first_row'", {
  tbl2 <- iris[c(1:4, 51:54), 3:5] |>
    mutate(s2 = paste0(Species, 1:2), s3 = s2) |>
    arrange(Species, s2) |>
    rtf_body(
      subline_by = "Species",
      page_by = "s2",
      pageby_row = "first_row"
    )

  pageby_exp <- data.frame(tbl2[c(1, 3, 5, 7), c(1:2, 5)])
  colnames(pageby_exp) <- paste("s2", colnames(pageby_exp), sep = ".")

  expect_identical(
    data.frame(attributes(tbl2)$rtf_by_subline_row),
    data.frame(x = unique(tbl2$Species))
  )

  expect_identical(
    data.frame(attributes(tbl2)$rtf_pageby_row),
    pageby_exp
  )

  expect_identical(
    attr(attr(tbl2, "rtf_by_subline_row"), "border_top"),
    matrix("", nrow = 2, ncol = 1)
  )

  expect_identical(
    attributes(attr(tbl2, "rtf_by_subline_row"))$border_bottom,
    matrix("", nrow = 2, ncol = 1)
  )
})

# Build Temporary vector for use in testing
teststr <- "The quick brown fox (){}[]$#&%@,.;:=_+-*/"

# Use rtf_text on temporary vector to use as input
rtf_text(
  text = teststr,
  font = 1,
  font_size = 6,
  format = "b",
  color = "black",
  background_color = "white"
)

# Check Temporary input attributes
teststratt <- attributes(teststr)

test_that("check valid input arguments to justification", {
  # Check justification argument matches justification()$type

  expect_error(
    rtf_paragraph(
      text = teststr,
      justification = 1
    ),
    "as.vector(justification) %in% para_justification$type is not TRUE",
    fixed = TRUE
  )
})

test_that("check valid input arguments to indent_first", {
  # Check indent_first argument only takes atomic numeric vector arguments

  expect_error(
    rtf_paragraph(
      text = teststr,
      indent_first = "4"
    ),
    "is.numeric(indent_first) is not TRUE",
    fixed = TRUE
  )
})

test_that("check valid input arguments to indent_left", {
  # Check indent_left argument only takes atomic numeric vector arguments

  expect_error(
    rtf_paragraph(
      text = teststr,
      indent_left = "4"
    ),
    "is.numeric(indent_left) is not TRUE",
    fixed = TRUE
  )
})

test_that("check valid input arguments to indent_right", {
  # Check indent_right argument only takes atomic numeric vector arguments

  expect_error(
    rtf_paragraph(
      text = teststr,
      indent_right = "4"
    ),
    "is.numeric(indent_right) is not TRUE",
    fixed = TRUE
  )
})

test_that("check valid input arguments to spacing", {
  # Check space argument matches spacing()$type

  expect_error(
    rtf_paragraph(
      text = teststr,
      space = "2.5"
    ),
    "space %in% spacing$type is not TRUE",
    fixed = TRUE
  )
})

test_that("check valid input arguments to space_before", {
  # Check space_before argument only takes atomic numeric vector arguments

  expect_error(
    rtf_paragraph(
      text = teststr,
      space_before = "4"
    ),
    "is.numeric(space_before) is not TRUE",
    fixed = TRUE
  )
})

test_that("check valid input arguments to space_after", {
  # Check space_after argument only takes atomic numeric vector arguments

  expect_error(
    rtf_paragraph(
      text = teststr,
      space_after = "4"
    ),
    "is.numeric(space_after) is not TRUE",
    fixed = TRUE
  )
})


test_that("check line, paragraph space encoding", {
  # Check paragraph space encoding

  expect_match(
    rtf_paragraph(
      text = teststr,
      space = 1.5
    ),
    "sl360\\\\slmult1"
  )

  # Check line space_before encoding

  expect_match(
    rtf_paragraph(
      text = teststr,
      space_before = 240
    ),
    "sb240"
  )

  # Check line space_after encoding

  expect_match(
    rtf_paragraph(
      text = teststr,
      space_after = 480
    ),
    "sa480"
  )
})

test_that("check page break encoding", {
  # Check page break new_page encoding

  expect_match(
    rtf_paragraph(
      text = teststr,
      new_page = TRUE
    ),
    "pagebb"
  )
})

test_that("check indentation, alignment encoding", {
  # Check alignment justification encoding

  expect_match(
    rtf_paragraph(
      text = teststr,
      justification = "d"
    ),
    "qj"
  )

  # Check indentation indent_first encoding

  expect_match(
    rtf_paragraph(
      text = teststr,
      indent_first = 134
    ),
    "fi134"
  )

  # Check indentation indent_left encoding

  expect_match(
    rtf_paragraph(
      text = teststr,
      indent_left = 134
    ),
    "li134"
  )

  # Check indentation indent_right encoding

  expect_match(
    rtf_paragraph(
      text = teststr,
      indent_right = 134
    ),
    "ri134"
  )
})

test_that("check hyphenation encoding", {
  # Check page break new_page encoding

  expect_match(
    rtf_paragraph(
      text = teststr,
      hyphenation = TRUE
    ),
    "hyphpar"
  )
})

# Build Temporary dataset for use in testing
testdat <- iris[1:100, ]

test_that("Check argument type, test if error message will show correctly", {
  expect_error(
    obj_rtf_border(tbl = testdat, border_left = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, border_right = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, border_top = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, border_bottom = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, border_color_left = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, border_color_right = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, border_color_top = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, border_color_bottom = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, cell_justification = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, border_width = "1"),
    "The argument type did not match: integer/numeric"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, cell_height = "1"),
    "The argument type did not match: integer/numeric"
  )
  expect_error(
    obj_rtf_border(tbl = testdat, cell_nrow = "1"),
    "The argument type did not match: integer/numeric"
  )
})

test_that("Check argument values, test if error message will show correctly", {
  expect_error(obj_rtf_border(tbl = testdat, border_left = "testing"))
  expect_error(obj_rtf_border(tbl = testdat, border_right = "testing"))
  expect_error(obj_rtf_border(tbl = testdat, border_top = "testing"))
  expect_error(obj_rtf_border(tbl = testdat, border_bottom = "testing"))
  expect_error(obj_rtf_border(tbl = testdat, border_color_left = "redd"))
  expect_error(obj_rtf_border(tbl = testdat, border_color_right = "redd"))
  expect_error(obj_rtf_border(tbl = testdat, border_color_top = "redd"))
  expect_error(obj_rtf_border(tbl = testdat, border_color_bottom = "redd"))
  expect_error(obj_rtf_border(tbl = testdat, cell_justification = "leftt"))
  expect_error(obj_rtf_border(tbl = testdat, border_width = -1))
  expect_error(obj_rtf_border(
    tbl = testdat, border_color_top = NULL,
    border_color_first = "red"
  ))
  expect_error(obj_rtf_border(
    tbl = testdat, border_color_bottom = NULL,
    border_color_last = "red"
  ))
})

test_that("Test if attributes are assigned correctly", {
  a <- obj_rtf_border(
    tbl = testdat, border_left = "single",
    border_right = "single",
    border_top = "single",
    border_bottom = "single",
    border_color_left = "red",
    border_color_right = "red",
    border_color_top = "red",
    border_color_bottom = "red",
    border_color_first = "red",
    border_color_last = "red",
    cell_justification = "l",
    border_width = 5,
    cell_height = 5,
    cell_nrow = 5
  )
  expect_equal(attr(a, "border_left")[1], "single")
  expect_equal(attr(a, "border_right")[1], "single")
  expect_equal(attr(a, "border_top")[1], "single")
  expect_equal(attr(a, "border_bottom")[1], "single")
  expect_equal(attr(a, "border_color_left")[1], "red")
  expect_equal(attr(a, "border_color_right")[1], "red")
  expect_equal(attr(a, "border_color_top")[1], "red")
  expect_equal(attr(a, "border_color_bottom")[1], "red")
  expect_equal(attr(a, "border_color_first")[1], "red")
  expect_equal(attr(a, "border_color_last")[1], "red")
  expect_equal(attr(a, "cell_justification")[1], "l")
  expect_equal(attr(a, "border_width")[1], 5)
  expect_equal(attr(a, "border_width")[1], 5)
  expect_equal(attr(a, "border_width")[1], 5)
})

test_that("Test if color_used is derived correctly", {
  a <- obj_rtf_border(
    tbl = testdat, border_left = "single",
    border_right = "single",
    border_top = "single",
    border_bottom = "single",
    border_color_left = "red",
    border_color_right = "red",
    border_color_top = "red",
    border_color_bottom = "red",
    border_color_first = "red",
    border_color_last = "red",
    cell_justification = "l",
    border_width = 5,
    cell_height = 5,
    cell_nrow = 5
  )
  expect_equal(attr(a, "use_color")[1], TRUE)

  a <- obj_rtf_border(
    tbl = testdat, border_left = "single",
    border_right = "single",
    border_top = "single",
    border_bottom = "single",
    border_color_left = "black",
    border_color_right = "black",
    border_color_top = "black",
    border_color_bottom = "black",
    border_color_first = "black",
    border_color_last = "black",
    cell_justification = "l",
    border_width = 5,
    cell_height = 5,
    cell_nrow = 5
  )
  expect_equal(attr(a, "use_color")[1], FALSE)
})

test_that("Test when input is a vector and attribute length is greater than 1", {
  expect_error(obj_rtf_border(
    tbl = iris[c(1:5), 1],
    border_top = c("single", "single")
  ))
})

test_that("Test when input is a vector and attribute length is equal to 1", {
  a <- obj_rtf_border(
    tbl = iris[c(1:5), 1],
    border_top = c("single")
  )
  expect_equal(attr(a, "border_top"), "single")
})

test_that("test if page attributes are assigned correctly", {
  a <- head(iris) |> rtf_subline(text = "sublinetest")

  expect_equal(attributes(a)$page$width, 8.5)
  expect_equal(attributes(a)$page$height, 11)
  expect_equal(attributes(a)$page$orientation, "portrait")
  expect_equal(attributes(a)$page$border_first, "double")
  expect_equal(attributes(a)$page$border_last, "double")
  expect_false(attributes(a)$page$use_color)
})

test_that("check justification when 'l' and 'r' ", {
  a <- head(iris) |> rtf_subline(text = "sublinetest")
  b <- head(iris) |> rtf_subline(text = "sublinetest", text_justification = "l")
  c <- head(iris) |> rtf_subline(text = "sublinetest", text_justification = "r")

  expect_equal(attributes(attributes(a)$rtf_subline)$text_justification, "l")
  expect_equal(attributes(attributes(b)$rtf_subline)$text_justification, "l")
  expect_equal(attributes(attributes(c)$rtf_subline)$text_justification, "r")
})


test_that("input argument checks", {
  expect_error(iris |> rtf_subline())
  expect_error(iris |> rtf_subline(text = "sublinetest", text_font = "1"))
  expect_error(iris |> rtf_subline(text = "sublinetest", text_format = 12))
  expect_error(iris |> rtf_subline(text = "sublinetest", text_font_size = "9"))
  expect_error(iris |> rtf_subline(text = "sublinetest", text_justification = "t"))
  expect_error(iris |> rtf_subline(text = "sublinetest", text_convert = "TRUE"))
})


test_that("check if use_color attribute is assigned correctly", {
  a <- head(iris) |> rtf_subline(text = "sublinetest", text_color = "blue")
  b <- head(iris) |> rtf_subline(text = "sublinetest", text_background_color = "green")
  c <- head(iris) |> rtf_subline(text = "sublinetest")

  expect_true(attributes(a)$page$use_color)
  expect_true(attributes(b)$page$use_color)
  expect_false(attributes(c)$page$use_color)
})

test_that("check justification when 'l' and text_indent_reference is table/page_margin ", {
  a <- head(iris) |>
    rtf_page(width = 5.5, col_width = 3) |>
    rtf_body()
  a_table <- a |> rtf_subline(text = "sublinetest", text_indent_reference = "table")
  expect_equal(attributes(attributes(a_table)$rtf_subline)$text_indent_left, 180)

  a_page <- a |> rtf_subline(text = "sublinetest", text_indent_reference = "page_margin")
  expect_equal(attributes(attributes(a_page)$rtf_subline)$text_indent_left, 0)
})

test_that("Case in defalut", {
  x <- iris[1:1, ] |>
    dplyr::select(1) |>
    rtf_body() |>
    as_rtf_table() |>
    strsplit("\n")

  expect_snapshot_output(x[[1]])
})

test_that("Case for border_color_left and border_color_top", {
  x <- iris[1:1, ] |>
    dplyr::select(1) |>
    rtf_body(border_color_left = "red", border_color_top = "blue") |>
    as_rtf_table() |>
    strsplit("\n")

  expect_snapshot_output(x[[1]])
})

test_that("Case for having group_by without page_by", {
  x <- iris[1:2, 4:5] |>
    rtf_body(group_by = "Species") |>
    as_rtf_table() |>
    strsplit("\n")

  expect_snapshot_output(x[[1]])
})


# add additional test to increase coverage and for new feature
test_that("Test case when subline is not NULL", {
  x <- iris[c(1:4, 51:54), 3:5] |>
    mutate(s2 = paste0(Species, 1:2), s3 = s2) |>
    arrange(Species, s2) |>
    rtf_body(
      subline_by = "Species",
      page_by = "s2",
    ) |>
    as_rtf_table() |>
    strsplit("\n")

  expect_snapshot_output(x[[1]])


  data(r2rtf_adae)
  ae <- r2rtf_adae[200:260, ] |>
    arrange(SITEID, TRTA, USUBJID, ASTDY)

  ae <- ae |>
    mutate(
      AEDECODNUM = as.character(rownames(ae)),
      SUBLINEBY = paste0(
        "Trial Number: ", STUDYID,
        ", Site Number: ", SITEID
      ),
    ) |>
    select(USUBJID, ASTDY, AEDECODNUM, TRTA, SUBLINEBY) |>
    arrange(SUBLINEBY, TRTA, USUBJID, ASTDY) |>
    rtf_colheader("Subject| Rel Day | Adverse Code|") |>
    rtf_body(
      subline_by = "SUBLINEBY",
      page_by = c("TRTA"),
      group_by = c("USUBJID", "ASTDY"),
    ) |>
    as_rtf_table() |>
    strsplit("\n")

  expect_snapshot_output(ae[[1]])
})

test_that("Case when choices is missing", {
  expect_error(match_arg(arg = "", choices = ))
})

test_that("Case when arg is NULL", {
  expect_equal(match_arg(NULL, c("a", "b", "c")), "a")
})

test_that("Case when arg can not be characterized as choices", {
  expect_error(match_arg(1, c("a", "b", "c")))
})

test_that("Case when arg is numeric", {
  expect_equal(match_arg(1, c("1", "2", "3")), "1")
  expect_equal(match_arg(1, c(1, 2, 3)), "1")
})

test_that("Case when several.ok is FALSE", {
  # if arg is same as choices
  expect_equal(match_arg(c("a", "b"), c("a", "b"), several.ok = FALSE), "a")
  # if arg length great than 1 but not same as choices
  expect_error(match_arg(c("a", "b"), c("a", "b", "c"), several.ok = FALSE))
})

test_that("Case when arg is in choices", {
  # if arg equals to ''
  expect_equal(match_arg("", choices = c("", "a", "b", "c")), "")
  # if arg NOT equals to ''
  expect_equal(match_arg("a", choices = c("", "a", "b", "c")), "a")
  # if arg has more than one match when several.ok is FALSE
  expect_error(match_arg(c("ab", "ab"), choices = c("abc", "ab"), several.ok = FALSE))
})

test_that("Case when arg is Not in choices", {
  expect_error(match_arg("d", choices = c("", "a", "b", "c")))
})

test_that("case when page footer equals to default", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_page_header()
  expect_equal(attr(x, "rtf_page_header")[1], "Page \\pagenumber of \\pagefield")
})

test_that("case when page footer equals to NULL", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_page_header(text = "")
  expect_equal(attr(x, "rtf_page_header")[1], "")
})

test_that("page header justification right and identation first 1, left 2", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_page_header(text = "testing", text_indent_first = 1, text_indent_left = 2, text_justification = "r")
  expect_equal(attr(attr(x, "rtf_page_header"), "text_indent_first"), 1)
  expect_equal(attr(attr(x, "rtf_page_header"), "text_indent_left"), 2)
  expect_equal(attr(attr(x, "rtf_page_header"), "text_justification"), "r")
})

test_that("page header justification left and identation left 2, right 3", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_page_header(text = "testing", text_indent_left = 2, text_indent_right = 3, text_justification = "l")
  expect_equal(attr(attr(x, "rtf_page_header"), "text_indent_left"), 2)
  expect_equal(attr(attr(x, "rtf_page_header"), "text_indent_right"), 3)
  expect_equal(attr(attr(x, "rtf_page_header"), "text_justification"), "l")
})


test_that("page header font=2, formats=bold", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_page_header(text = "testing", text_font = 2, text_format = "b")
  expect_equal(attr(attr(x, "rtf_page_header"), "text_font"), 2)
  expect_equal(attr(attr(x, "rtf_page_header"), "text_format"), "b")
})

test_that("footnote text color red", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_page_header(text = "testing", text_color = "red")
  expect_equal(attr(attr(x, "rtf_page_header"), "text_color"), "red")
})

library(dplyr)
test_that("Test fig_format attribute", {
  a <- rtf_read_figure(c("fig/fig3.jpeg", "fig/fig2.png", "fig/fig4.emf"))

  expect_equal(sum(attr(a, "fig_format") == c("jpeg", "png", "emf")), 3)
})

test_that("Test outputs", {
  a <- rtf_read_figure(c("fig/fig3.jpeg", "fig/fig2.png", "fig/fig4.emf")) |>
    rtf_figure() |>
    rtf_encode(doc_type = "figure")

  expect_snapshot_output(a)
})

## create temporary dataset to run the testing
data1 <- iris[1:2, ]
data2 <- data1 |> rtf_body()

test_that("Test if type input is not table or figure", {
  expect_error(data2 |> rtf_encode(type = "plot"))
})

test_that("Test if title/footnote/source input is not first, all, last", {
  expect_error(data2 |> rtf_encode(page_title = "middle"))
  expect_error(data2 |> rtf_encode(page_footnote = "firstlast"))
  expect_error(data2 |> rtf_encode(page_source = "ALL"))
})

test_that("Test if content is converted to RTF correctly when tbl class is list", {
  x <- data.frame(1) |> rtf_body()
  y <- data.frame(1) |> rtf_body()
  z <- list(x, y)
  expect_snapshot_output(rtf_encode(z, doc_type = "table"))
})

test_that("Test if content is converted to RTF correctly when tbl class is data.frame", {
  expect_snapshot_output(rtf_encode(data2, doc_type = "table"))
})


tbl <- rtf_read_figure("fig/fig1.png") |> rtf_figure()
tbl2 <- tbl |>
  rtf_title("This is the title") |>
  rtf_footnote("This is a footnote")
tbl3 <- tbl2 |> rtf_encode(doc_type = "figure")


test_that("Test if content is converted to RTF correctly when type is figure", {
  expect_true(grep("{\\rtf1\\ansi\n\\deff0\\", tbl3, fixed = TRUE) == 1)
})

# Build Temporary vector for use in testing
teststr <- "The quick brown fox (){}[]$#&%@,.;:=_+-*/"

# Check Temporary dataset attributes
teststratt <- attributes(teststr)

test_that("RTF text default color", {
  # Check no default color assigned for foreground when background color is null

  expect_false(c("cf") %in%
    rtf_text(text = teststr))

  # Check default black color is assigned for foreground when background color is not null

  expect_match(
    rtf_text(
      text = teststr,
      background_color = "white"
    ),
    "cf24"
  )
})

test_that("check for valid input arguments to font", {
  # Check font argument matches font_type()$type

  expect_error(
    rtf_text(
      text = teststr,
      font = "xyz"
    ),
    "font %in% font_type$type is not TRUE",
    fixed = TRUE
  )
})

test_that("check for valid input arguments to font_size", {
  # Check font_size argument only takes atomic numeric vector arguments

  expect_error(
    rtf_text(
      text = teststr,
      font_size = "xyz"
    ),
    "is.numeric(font_size) is not TRUE",
    fixed = TRUE
  )
})

test_that("check for valid input arguments to format", {
  # Check format argument matches font_format()$type

  expect_error(rtf_text(text = teststr, format = "xyz"))
})

test_that("check for valid input arguments to color", {
  # Check color argument matches color_table()$color

  expect_error(
    rtf_text(
      text = teststr,
      color = "check"
    ),
    "color %in% col_tb$color is not TRUE",
    fixed = TRUE
  )
})

test_that("check for valid input arguments to background_color", {
  # Check background_color argument matches color_table()$color

  expect_error(
    rtf_text(
      text = teststr,
      background_color = "check"
    ),
    "background_color %in% col_tb$color is not TRUE",
    fixed = TRUE
  )
})

test_that("text font, size and format checks", {
  # Check font

  expect_match(
    rtf_text(
      text = teststr,
      font = 2
    ),
    "f1"
  )

  expect_match(
    rtf_text(
      text = teststr,
      font = 3
    ),
    "f2"
  )

  # Check font_size

  expect_match(
    rtf_text(
      text = teststr,
      font_size = 2
    ),
    "fs4"
  )

  expect_match(
    rtf_text(
      text = teststr,
      font_size = 100
    ),
    "fs200"
  )

  # Check format

  expect_match(
    rtf_text(
      text = teststr,
      format = "b"
    ),
    "\\b"
  )

  expect_match(
    rtf_text(
      text = teststr,
      format = "ib"
    ),
    "\\i\\b"
  )
})

test_that("text color checks", {
  # Check foreground color

  expect_match(
    rtf_text(
      text = teststr,
      color = "red",
      background_color = "white"
    ),
    "cf552"
  )

  expect_match(
    rtf_text(
      text = teststr,
      color = "yellow4",
      background_color = "white"
    ),
    "cf656"
  )

  # Check background_color

  expect_match(
    rtf_text(
      text = teststr,
      color = "white",
      background_color = "darkviolet"
    ),
    "cb115"
  )

  expect_match(
    rtf_text(
      text = teststr,
      color = "white",
      background_color = "mistyrose"
    ),
    "cb479"
  )
})

test_that("case when rtf_page is null and footnote equals to null", {
  x <- iris |>
    rtf_body() |>
    rtf_footnote(footnote = )
  expect_equal(attr(x, "rtf_footnote")[1], "")
})

test_that("case when footnote equals to null", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_footnote(footnote = )
  expect_equal(attr(x, "rtf_footnote")[1], "")
})


test_that("footnote justification left and identation first 1 left 2", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_footnote(footnote = "testing", text_indent_first = 1, text_indent_left = 2, text_justification = "r")

  expect_equal(attr(attr(x, "rtf_footnote"), "text_indent_first"), 1)
  expect_equal(attr(attr(x, "rtf_footnote"), "text_indent_left"), 2)
  expect_equal(attr(attr(x, "rtf_footnote"), "text_justification"), "r")
})

test_that("footnote justification left and identation left 2", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_footnote(footnote = "testing", text_indent_left = 2, text_indent_right = 3, text_justification = "l")

  expect_equal(attr(attr(x, "rtf_footnote"), "text_indent_left"), 2)
  expect_equal(attr(attr(x, "rtf_footnote"), "text_indent_right"), 3)
  expect_equal(attr(attr(x, "rtf_footnote"), "text_justification"), "l")
})


test_that("footnote font is 2, formats is bold", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_footnote(footnote = "testing", text_font = 2, text_format = "b")
  expect_equal(attr(attr(x, "rtf_footnote"), "text_font"), 2)
  expect_equal(attr(attr(x, "rtf_footnote"), "text_format"), "b")
})

test_that("footnote text color red", {
  x <- iris |>
    rtf_page() |>
    rtf_body() |>
    rtf_footnote(footnote = "testing", text_color = "red")
  expect_equal(attr(attr(x, "rtf_footnote"), "text_color"), "red")
})

test_that("footnote justification right and identation right 2, and text_indent_reference is table/page_margin", {
  x <- iris |>
    rtf_page(width = 6, col_width = 3) |>
    rtf_body()
  x_table <- x |> rtf_footnote(
    footnote = "testing", text_indent_right = 2, text_justification = "r",
    text_indent_reference = "table"
  )
  expect_equal(attr(attr(x_table, "rtf_footnote"), "text_indent_right"), 2)

  x_page <- x |> rtf_footnote(
    footnote = "testing", text_indent_right = 2, text_justification = "r",
    text_indent_reference = "page_margin"
  )
  expect_equal(attr(attr(x_page, "rtf_footnote"), "text_indent_right"), 2 + 0)
})

file <- file.path(tempdir(), "tmp.rtf")

iris[1:2, 1:2] |>
  rtf_body() |>
  rtf_encode() |>
  write_rtf(file)

x <- readLines(file)

x[24] <- gsub("4500", "4501", x[24])
x[36] <- gsub("4500", "4502", x[36])
x[31] <- gsub("9000", "9001", x[31])

y <- update_cellx(x)

test_that("border twips were updated to maxinum as expected", {
  expect_equal(sum(grepl("cellx4502", y[24]), grepl("cellx4502", y[30]), grepl("cellx4502", y[36]), grepl("cellx9001", y[31])), 4)
})


test_that("attribute was updated with correct maximum twip", {
  expect_equal(attr(y, "max_twip"), max(as.numeric(gsub("cellx", "", unique(unlist(regmatches(x, gregexpr("cellx([0-9]+)", x))))))))
})

test_that("rtf_rich_text fundamentally works.", {
  output <- rtf_rich_text(
    text = "This is {.emph important}. This is {.blah relevant}.",
    theme = list(
      .emph = list(color = "blue", `format` = "b"),
      .blah = list(color = "red")
    )
  )

  expectation <- rtf_text(paste0(
    "This is ",
    rtf_text("important", color = "blue", `format` = "b"),
    ". This is ",
    rtf_text("relevant", color = "red"),
    "."
  ))

  expect_equal(output, expectation)
})

test_that("rtf_rich_text works with example from check_args.", {
  output <- r2rtf:::rtf_paragraph(
    r2rtf:::rtf_rich_text(
      text = "3.5{^\\dagger}\n{.red red} {.hl highlight}",
      theme = list(
        .red = list(color = "red"),
        .hl = list(background_color = "yellow")
      )
    )
  )

  expectation <- r2rtf:::rtf_paragraph(
    r2rtf:::rtf_text(paste0(
      "3.5{^\\dagger}\\line ",
      r2rtf:::rtf_text("red", color = "red"),
      " ",
      r2rtf:::rtf_text("highlight", background_color = "yellow")
    ))
  )

  expect_equal(output, expectation)
})

dt <- iris[c(1:5, 51:55, 101:105), ] |> dplyr::arrange(Species)


# test_that("Test when data is not sorted by group_by variable", {
#   dt1 <- dt |> dplyr::arrange(Sepal.Width)
#   expect_error(case1 <- rtf_group_by_enhance(dt1, "Species", 1))
#
# })

test_that("Test when data is sorted by group_by variable", {
  case2 <- rtf_group_by_enhance(dt, "Species", (1))
  dt2 <- dt
  ls <- c(1:dim(dt2)[1])
  keep <- c(1, 6, 11)
  for (val in ls) {
    if (!(val %in% keep)) (dt2[val, 5] <- NA)
  }
  expect_equal(case2, dt2)
})

test_that("Test if duplicated records are removed in returned dataset", {
  dt3 <- rbind(dt, dt[3, ])
  dt3 <- dplyr::arrange(dt3, Species)
  case3 <- rtf_group_by_enhance(dt3, "Species", (1))

  expect_equal(as.logical(case3[2, 5]), NA)
})

test_that("Test if no records will be deleted when there are no duplicated records", {
  dt4 <- iris[c(1, 51, 101), ] |> dplyr::arrange(Species)
  case4 <- rtf_group_by_enhance(dt4, "Species", rep(1, 3))

  expect_equal(dt4, case4)
})

# create testing example
svg(tempfile("tmp.svg"))

font <- 2:3
format <- matrix(c("", "i", "b", "ib"), nrow = 4, ncol = 2, byrow = FALSE)
size <- matrix(9:9, nrow = 4, ncol = 2, byrow = FALSE)
indent_first <- matrix(c(0, 80), nrow = 4, ncol = 2, byrow = FALSE)
indent_left <- matrix(c(0, 300), nrow = 4, ncol = 2, byrow = FALSE)

tbl1 <- matrix("RStudio is an integrated development environment for R, a programming language for statistical computing and graphics.", nrow = 2, ncol = 2)
tbl2 <- matrix("RStudio", nrow = 2, ncol = 2)
tbl <- rbind(tbl1, tbl2)

tbl <- data.frame(tbl) |>
  rtf_page(orientation = "portrait") |>
  rtf_title(title = c(
    "title here",
    "title 2 here",
    "here is a very very very very very long title 3 that should be broken to two lines if calculated correctly"
  )) |>
  rtf_subline(text = c(
    "subline 1",
    "this is a very long subline that should be broken to 2 lines if calculated correctly by rtf_nrow function"
  )) |>
  rtf_colheader(
    colheader = "a long column 1 header to test line break|col2",
    col_rel_width = c(1, 5)
  ) |>
  rtf_footnote(footnote = c(
    "footer1",
    "this is a very very very very very very very long footer2 that should be broken to 2 lines if calculated correctly by rtf_nrow function"
  )) |>
  rtf_source(source = c("source here", "source 2")) |>
  rtf_body(
    text_justification = "l",
    col_rel_width = c(1, 5),
    text_font = font,
    text_font_size = size,
    text_format = format,
    text_indent_first = indent_first,
    text_indent_left = indent_left
  )
# tbl |> rtf_encode() |> write_rtf("tmp.rtf")


# rtf_nrow
tbl1 <- rtf_nrow(tbl)
bodys <- attr(tbl1, "rtf_nrow")
titles <- attr(tbl1, "rtf_nrow_meta")$title
sublines <- attr(tbl1, "rtf_nrow_meta")$subline
headers <- attr(tbl1, "rtf_nrow_meta")$col_header
footers <- attr(tbl1, "rtf_nrow_meta")$footnote
sources <- attr(tbl1, "rtf_nrow_meta")$source


# nrow_paragraph
nrowpara_title <- nrow_paragraph(attr(tbl, "rtf_title"), size = 6.25, padding = 0)
nrowpara_subline <- nrow_paragraph(attr(tbl, "rtf_subline"), size = 6.25, padding = 0)
nrowpara_footer <- nrow_paragraph(attr(tbl, "rtf_footnote"), size = 6.25, padding = 0)
nrowpara_source <- nrow_paragraph(attr(tbl, "rtf_source"), size = 6.25, padding = 0)


# nrow_table
nrowtable <- nrow_table(tbl, size = 6.25)
nrowtablefooter <- nrow_table(attr(tbl, "rtf_footnote"), size = 6.25)
nrowtablesource <- nrow_table(attr(tbl, "rtf_source"), size = 6.25)


# rnow_table cell size calculation
pad <- (attr(tbl, "text_indent_left") + attr(tbl, "text_indent_right")) / 1440 + 0.2
rel_width <- attr(tbl, "col_rel_width")
width <- 6.25 * rel_width / sum(rel_width)
cellsize <- matrix(width, nrow = nrow(tbl), ncol = ncol(tbl), byrow = TRUE) - pad


# rtf_nline_vector example
nline_vector <- rtf_nline_vector(
  text = c("title 1", "this is a sentence for title 2", NA),
  strwidth = c(
    strwidth("title 1", units = "inches"),
    strwidth("this is a sentence for title 2", units = "inches")
  ),
  size = 0.5
)


# rtf_nline_matrix example
mtx <- matrix("this is a sentence for title 2", nrow = 2, ncol = 2)
mtxstrwidth <- matrix(2, nrow = 2, ncol = 2)
mtxsize <- matrix(5:8 / 10, nrow = 2)
nline_matrix <- rtf_nline_matrix(text = mtx, strwidth = mtxstrwidth, size = mtxsize)


# pageby example

iris[1:2, 1] <- "a long string to test line breaks"

irs <- iris[1:55, ] |>
  rtf_title(title = "pageby example") |>
  rtf_body(page_by = "Species", new_page = TRUE)
# irs |> rtf_encode() |> write_rtf("tmp.rtf")

irs1 <- rtf_nrow(irs)
irsbodys <- attr(irs1, "rtf_nrow")
irspagebybodys <- attr(attr(irs1, "rtf_pageby_table"), "rtf_nrow")
irspagebyrows <- attr(attr(irs1, "rtf_pageby_row")$Species, "rtf_nrow")



test_that("test if rtf_nline_vector() return to correct numbers", {
  # line for first vector
  expect_equal(nline_vector[1], 1)

  # lines for second vector
  expect_equal(nline_vector[2], 6)
})

test_that("test if rtf_nline_matrix() return to correct numbers", {
  # maximum lines for first row
  expect_equal(nline_matrix[1], 6)

  # maximum lines for second row
  expect_equal(nline_matrix[2], 5)
})


test_that("test if nrow_paragraph() return to correct number of titles when there are 3 title lines", {
  # title lines through rtf_nrow
  expect_equal(titles, 4)

  # subline lines through nrow_paragraph
  expect_equal(sum(nrowpara_title), 4)
})


test_that("test if nrow_paragraph() return to correct number of sublines", {
  # subline lines through rtf_nrow
  expect_equal(sublines, 3)

  # subline lines through nrow_paragraph
  expect_equal(sum(nrowpara_subline), 3)
})


test_that("test for nrow_table() when as_table attr is FALSE", {
  expect_equal(sum(nrowpara_source), sources)
})


test_that("test for nrow_table() when as_table attr is TRUE", {
  expect_equal(sum(nrowtablefooter), footers)
})


test_that("test for nrow_table() if actual column size are calculated correctly", {
  # first cell size calculated within nrow_table
  expect_equal(round(cellsize[1, 1], 5), round(6.25 * 1 / 6 - 0.2, 5))

  if (interactive()) {
    # first cell returned lines through nrow_table
    expect_true(nrowtable[1] >= 10)

    # first cell returned lines through rtf_nrow
    expect_true(bodys[1] >= 10)
  }
})


test_that("test for rtf-nrow() if 'rtf-nrow' attributes are added correctly for pageby table", {
  expect_equal(irspagebybodys[1], 2)
})


test_that("test for rtf-nrow() if 'rtf-nrow' attributes are added correctly for pageby_row table", {
  expect_equal(irspagebyrows[1], 1)
})

dev.off()

# test bulletproofing
file <- replicate(2, tempfile(fileext = ".rtf"))
file1 <- head(iris) |>
  rtf_body() |>
  rtf_encode() |>
  write_rtf(file[1])
file2 <- head(cars) |>
  rtf_page(orientation = "landscape") |>
  rtf_body() |>
  rtf_encode() |>
  write_rtf(file[2])

test_that("rtf_assemble: bulletproofing argument landscape", {
  expect_error(assemble_rtf(
    input = file,
    output = tempfile(fileext = ".rtf"),
    landscape = "yes"
  ))

  expect_error(assemble_docx(
    input = file,
    output = tempfile(fileext = ".docx"),
    landscape = c(TRUE, TRUE, FALSE)
  ))
})

test_that("rtf_assemble: bulletproofing argument input", {
  expect_error(assemble_rtf(input = c(TRUE, TRUE), output = tempfile(fileext = ".rtf")))
})

test_that("rtf_assemble: bulletproofing argument output", {
  expect_error(assemble_rtf(input = file, output = TRUE))
})

# test functionality without officer
test_that("rtf_assemble: output without using officer", {
  file_tmp <- tempfile(fileext = ".rtf")
  rtf_path <- assemble_rtf(input = file, output = file_tmp)

  expect_equal(rtf_path, file_tmp)

  tmp_rtf <- paste(readLines(rtf_path), collapse = "\n")

  expect_true(grepl(tmp_rtf, pattern = "Sepal"))
  expect_true(grepl(tmp_rtf, pattern = "speed"))
})

# test functionality with officer
if (requireNamespace("officer")) {
  test_that("rtf_assemble: output with using officer", {
    file_tmp <- tempfile(fileext = ".docx")
    rtf_path <- assemble_docx(
      input = file,
      output = file_tmp,
      landscape = c(FALSE, TRUE)
    )

    expect_equal(rtf_path, file_tmp)

    # Need to read in and expose document text for our test
    docx <- officer::read_docx(rtf_path)
    tmp_docx <- officer::docx_summary(docx)
    body_docx <- officer::docx_body_xml(docx)

    # Need to check if both "table seq table" texts are in the docx file.
    expect_true(grepl("Table SEQ Table", tmp_docx$text[1]))

    expect_equal(
      unlist(lapply(xml2::as_list(xml2::xml_find_all(body_docx, "//w:pgSz")), FUN = function(x) attr(x, "orient"))),
      c("portrait", "landscape")
    )
  })
}

tbl <- rtf_read_figure("fig/fig1.png") |>
  rtf_figure(
    fig_width = 5,
    fig_height = 5
  ) # page and image size set here

tbl <- tbl |>
  rtf_title("This is the title") |>
  rtf_footnote("This is a footnote") |>
  rtf_source("Source:  This is the source]")

attr(tbl, "page")$page_title <- "first"
attr(tbl, "page")$page_footnote <- "all"
attr(tbl, "page")$page_source <- "all"

tbl_encode <- tbl |> rtf_encode_figure()


test_that("figure width and height encoding", {
  fig_size <- "{\\pict\\pngblip\\picwgoal7200\\pichgoal7200"

  expect_true(grep(fig_size, tbl_encode, fixed = TRUE) == 2)
})

test_that("RTF page, margin encoding", {
  page_size <- "\\paperw12240\\paperh15840"

  expect_true(grep(page_size, tbl_encode, fixed = TRUE) == 2)

  margin_omi <- c(1.25, 1, 1.75, 1.25, 1.75, 1.00625) # the margin for "wma" and "portrait"
  margin <- c("\\margl", "\\margr", "\\margt", "\\margb", "\\headery", "\\footery")
  margin <- paste(paste0(margin, inch_to_twip(margin_omi)), collapse = "")
  margin <- paste0(margin, "\n")

  expect_true(grep(margin, tbl_encode, fixed = TRUE) == 2)
})

test_that("RTF title, footnote and source encoding", {
  # Footnote always be free text in figures
  footnote <- attr(tbl, "rtf_footnote")
  if (!is.null(footnote)) {
    attr(footnote, "as_table") <- FALSE
    attr(tbl, "rtf_footnote") <- footnote
  }

  title_rtftext <- as_rtf_title(tbl)
  footnote_rtftext <- as_rtf_footnote(tbl)
  source_rtftext <- as_rtf_source(tbl)

  expect_true(grep(title_rtftext, tbl_encode, fixed = TRUE) == 2)
  expect_true(grep(footnote_rtftext, tbl_encode, fixed = TRUE) == 2)
  expect_true(grep(source_rtftext, tbl_encode, fixed = TRUE) == 2)
})


test_that("RTF title, footnote and source encoding other case for locations", {
  attr(tbl, "page")$page_title <- "last"
  attr(tbl, "page")$page_footnote <- "first"
  attr(tbl, "page")$page_source <- "first"

  tbl_encode1 <- rtf_encode_figure(tbl)

  footnote <- attr(tbl, "rtf_footnote")
  if (!is.null(footnote)) {
    attr(footnote, "as_table") <- FALSE
    attr(tbl, "rtf_footnote") <- footnote
  }

  title_rtftext <- as_rtf_title(tbl)
  footnote_rtftext <- as_rtf_footnote(tbl)
  source_rtftext <- as_rtf_source(tbl)

  expect_true(grep(title_rtftext, tbl_encode, fixed = TRUE) == 2)
  expect_true(grep(footnote_rtftext, tbl_encode, fixed = TRUE) == 2)
  expect_true(grep(source_rtftext, tbl_encode, fixed = TRUE) == 2)
})

test_that("RTF title, footnote and source encoding other case for locations", {
  attr(tbl, "page")$page_title <- "last"
  attr(tbl, "page")$page_footnote <- "last"
  attr(tbl, "page")$page_source <- "last"

  tbl_encode1 <- rtf_encode_figure(tbl)

  footnote <- attr(tbl, "rtf_footnote")
  if (!is.null(footnote)) {
    attr(footnote, "as_table") <- FALSE
    attr(tbl, "rtf_footnote") <- footnote
  }

  title_rtftext <- as_rtf_title(tbl)
  footnote_rtftext <- as_rtf_footnote(tbl)
  source_rtftext <- as_rtf_source(tbl)

  expect_true(grep(title_rtftext, tbl_encode, fixed = TRUE) == 2)
  expect_true(grep(footnote_rtftext, tbl_encode, fixed = TRUE) == 2)
  expect_true(grep(source_rtftext, tbl_encode, fixed = TRUE) == 2)
})

test_that("Report ERROR if libreoffice7.1 is not avaiable", {
  skip_on_cran()
  skip_on_os(c("windows", "mac", "solaris"))
  file <- file.path(tempdir(), "tmp.rtf")
  iris |>
    head() |>
    rtf_body() |>
    rtf_encode() |>
    write_rtf(file)
  if (system("which libreoffice7.1", ignore.stderr = TRUE, ignore.stdout = TRUE) == 1) {
    expect_error(rtf_convert_format(input = file, output_dir = tempdir()))
  } else {
    expect_equal(rtf_convert_format(input = file, output_dir = tempdir()), file.path(tempdir(), "tmp.pdf"))
  }
})

# create testing example

df <- data.frame(
  x = rep("This is a long sentence", 5),
  y = "short",
  z = "third"
)

tbl <- df |>
  rtf_body(
    text_font = c(1, 9, 1),
    text_font_size = 8,
    text_format = c("i", "b", "b")
  )

strw <- round(r2rtf:::rtf_strwidth(tbl), 5)

size8italic <- round(graphics::strwidth("This is a long sentence",
  units = "inches",
  cex = 2 / 3,
  font = 3,
  family = "Times"
), 5)

bold <- round(graphics::strwidth("third",
  units = "inches",
  cex = 2 / 3,
  font = 2,
  family = "Times"
), 5)


test_that("test if width are calculated correctly for case when font size is 8", {
  font_type()

  expect_equal(strw[1, 1], size8italic)
})


test_that("test if width are calculated correctly for case when font format is bold", {
  expect_equal(strw[1, 3], bold)
})


test_that("test if width are calculated correctly for case when font format is italic", {
  expect_equal(strw[1, 1], size8italic)
})


test_that("test if width are calculated correctly for case when 'Courier New' is used", {
  expect_equal(strw[1, 2], round(5 * 8 * 0.52 / 72, 5))
})

## create temporary dataset to run the testing
data1 <- iris[1:2, ]
data2 <- data1 |> rtf_body(
  as_colheader = TRUE,
  col_rel_width = c(5, 9, 13, 18, 9)
)

# create rtf encode table
attr(data2, "page")$page_title <- "all"
attr(data2, "page")$page_footnote <- "last"
attr(data2, "page")$page_source <- "last"

data3 <- data2 |> rtf_encode_table()

test_that("RTF page, margin encoding", {
  expect_snapshot_output(data3)
})

test_that("RTF colheader", {
  d1 <- iris[1:100, ]
  d2 <- d1 |> rtf_body(
    as_colheader = TRUE,
    col_rel_width = rep(1, ncol(d1))
  )

  attr(d2, "page")$page_title <- "all"
  attr(d2, "page")$page_footnote <- "last"
  attr(d2, "page")$page_source <- "last"

  encode2 <- rtf_encode_table(d2)

  colheader <- attr(d2, "rtf_colheader")

  if (length(colheader) > 0) {
    head <- attributes(colheader[[1]])$border_top
    attributes(colheader[[1]])$border_top <- matrix(attr(d2, "page")$border_first, nrow = 1, ncol = ncol(head))

    colheader_rtftext_1 <- lapply(colheader, rtf_table_content,
      use_border_bottom = TRUE,
      col_total_width = attr(d2, "page")$col_width
    )

    colheader_rtftext_2 <- unlist(colheader_rtftext_1)

    colheader_rtftext_3 <- paste(unlist(colheader_rtftext_2), collapse = "\n")
  }

  expect_true(grep(colheader_rtftext_3, encode2, fixed = TRUE) == 2)
})


test_that("RTF header, footnote and source encoding", {
  # create test data
  d1 <- iris[1:2, ]
  d2 <- d1 |> rtf_body(
    as_colheader = TRUE,
    col_rel_width = rep(1, ncol(d1)),
    border_width = 12,
    cell_height = 0.15,
    page_by = NULL,
    new_page = FALSE
  )

  d3 <- d2 |>
    rtf_footnote("Test footnote xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx",
      border_width = 15,
      cell_height = 0.15,
      cell_justification = "c",
    ) |>
    rtf_source("[Source:  mk9999testing]",
      text_indent_first = 1, text_indent_left = 0,
      text_indent_right = 0
    ) |>
    rtf_title("Title Testing")


  attr(d3, "page")$page_title <- "last"
  attr(d3, "page")$page_footnote <- "first"
  attr(d3, "page")$page_source <- "last"

  encode <- d3 |> rtf_encode_table()


  expect_true(grep(as_rtf_footnote(d3), encode, fixed = TRUE) == 2)
  expect_true(grep(as_rtf_source(d3), encode, fixed = TRUE) == 2)
  expect_true(grep(as_rtf_title(d3), encode, fixed = TRUE) == 2)
})


test_that("RTF header, footnote and source encoding for different location", {
  # create test data
  d1 <- iris[1:2, ]
  d2 <- d1 |> rtf_body(
    as_colheader = TRUE,
    col_rel_width = rep(1, ncol(d1)),
    border_width = 12,
    cell_height = 0.15,
    page_by = NULL,
    new_page = FALSE
  )

  d3 <- d2 |>
    rtf_footnote("Test footnote xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx",
      border_width = 15,
      cell_height = 0.15,
      cell_justification = "c",
    ) |>
    rtf_source("[Source:  mk9999testing]",
      text_indent_first = 1, text_indent_left = 0,
      text_indent_right = 0
    ) |>
    rtf_title("Title Testing")

  attr(d3, "page")$page_title <- "first"
  attr(d3, "page")$page_footnote <- "last"
  attr(d3, "page")$page_source <- "first"

  encode1 <- d3 |> rtf_encode_table()

  # assign defult value ..
  k <- attr(d3, "rtf_footnote")
  attr(k, "border_bottom") <- attr(d3, "page")$border_last
  attr(d3, "rtf_footnote") <- k
  footnote_rtftext_1 <- as_rtf_footnote(d3)



  expect_true(grep(as_rtf_footnote(d3), encode1, fixed = TRUE) == 2)
  expect_true(grep(as_rtf_source(d3), encode1, fixed = TRUE) == 2)
  expect_true(grep(as_rtf_title(d3), encode1, fixed = TRUE) == 2)
})



test_that("input value test if data frame or list of data frames", {
  m <- iris[1:2, ]
  m1 <- m |> rtf_body(
    as_colheader = TRUE,
    col_rel_width = c(5, 9, 13, 18, 9)
  )

  attr(m1, "page")$page_title <- "all"
  attr(m1, "page")$page_footnote <- "last"
  attr(m1, "page")$page_source <- "last"
  m1 <- rtf_encode_table(m1)

  expect_snapshot_output(m1)
})


test_that("Test case when source are included as table", {
  m <- iris[1:2, ]
  m1 <- m |>
    rtf_body(
      as_colheader = TRUE,
      col_rel_width = c(5, 9, 13, 18, 9)
    ) |>
    rtf_source("source text", as_table = TRUE)

  attr(m1, "page")$page_title <- "all"
  attr(m1, "page")$page_footnote <- "last"
  attr(m1, "page")$page_source <- "last"
  m1 <- rtf_encode_table(m1)

  expect_snapshot_output(m1)
})

test_that("Test case when page_by var is not NULL", {
  m <- iris[1:60, ]
  m1 <- m |>
    dplyr::arrange(Species) |>
    rtf_body(
      page_by = "Species",
      as_colheader = TRUE,
      col_rel_width = c(5, 9, 13, 18, 9),
      border_color_bottom = "black",
      border_color_last = "red"
    )

  attr(m1, "page")$page_title <- "all"
  attr(m1, "page")$page_footnote <- "last"
  attr(m1, "page")$page_source <- "last"
  m1 <- rtf_encode_table(m1)

  expect_snapshot_output(m1)
})


test_that("Test case when footnote and source display in all pages", {
  m <- iris[1:60, ]
  m1 <- m |>
    dplyr::arrange(Species) |>
    rtf_body(
      page_by = "Species",
      as_colheader = TRUE,
      col_rel_width = c(5, 9, 13, 18, 9),
      border_color_bottom = "black",
      border_color_last = "red"
    )

  attr(m1, "page")$page_title <- "all"
  attr(m1, "page")$page_footnote <- "last"
  attr(m1, "page")$page_source <- "last"

  m1 <- rtf_encode_table(m1)

  expect_snapshot_output(m1)
})


# add additional test to increase coverage and for new feature
test_that("Test case when page$border_color_first is not NULL", {
  ir <- head(iris, 2) |>
    rtf_page(border_color_first = "red") |>
    rtf_body()

  ir <- rtf_encode_table(ir)

  expect_snapshot_output(ir)
})

test_that("Test case when pageby$border_color_last is not NULL", {
  ir2 <- head(iris, 2) |>
    rtf_page(border_color_last = "red") |>
    rtf_body()

  ir2 <- rtf_encode_table(ir2)

  expect_snapshot_output(ir2)
})

test_that("Test case when subline is not NULL", {
  ir3 <- iris[c(1:4, 51:54), 3:5] |>
    mutate(s2 = paste0(Species, 1:2)) |>
    arrange(Species, s2) |>
    rtf_colheader("patelLength|patelWidth|s2") |>
    rtf_body(subline_by = "Species")

  ir3 <- rtf_encode_table(ir3)

  expect_snapshot_output(ir3)
})

test_that("Test case when subline is not NULL and verbose equals to TRUE", {
  ir3 <- iris[c(1:4, 51:54), 3:5] |>
    mutate(s2 = paste0(Species, 1:2)) |>
    arrange(Species, s2) |>
    rtf_colheader("patelLength|patelWidth|s2") |>
    rtf_body(subline_by = "Species")

  ir3 <- rtf_encode_table(ir3, verbose = TRUE)

  expect_true(length(ir3$info) > 0)
})

test_that("Test case when using subline_by, page_by, group_by simultaneously in rtf_body", {
  data(r2rtf_adae)
  ae_t1 <- r2rtf_adae[200:260, ] |>
    mutate(
      SUBLINEBY = paste0(
        "Trial Number: ", STUDYID,
        ", Site Number: ", SITEID
      ),
    ) |>
    select(USUBJID, ASTDY, AEDECOD, TRTA, SUBLINEBY) |>
    arrange(SUBLINEBY, TRTA, USUBJID, ASTDY) |>
    rtf_colheader("Subject| Rel Day | Adverse |") |>
    rtf_body(
      subline_by = "SUBLINEBY",
      page_by = c("TRTA"),
      group_by = c("USUBJID", "ASTDY"),
    )

  ae_t1 <- rtf_encode_table(ae_t1)

  expect_snapshot_output(ae_t1)
})


test_that("Test case when using subline_by, page_by, group_by simultaneously with pageby_row = 'first_row' and new_page = TRUE in rtf_body", {
  data(r2rtf_adae)
  ae_t2 <- r2rtf_adae[200:260, ] |>
    subset(USUBJID != "01-701-1442") |>
    mutate(
      SUBLINEBY = paste0(
        "Trial Number: ", STUDYID,
        ", Site Number: ", SITEID
      ),
    ) |>
    select(USUBJID, ASTDY, AEDECOD, TRTA, SUBLINEBY) |>
    arrange(SUBLINEBY, TRTA, USUBJID, ASTDY) |>
    rtf_colheader("Subject| Rel Day | Adverse |",
      border_bottom = "single"
    ) |>
    rtf_body(
      subline_by = "SUBLINEBY",
      page_by = c("TRTA"),
      pageby_row = "first_row",
      new_page = TRUE,
      group_by = c("USUBJID", "ASTDY")
    )

  ae_t2 <- rtf_encode_table(ae_t2)

  expect_snapshot_output(ae_t2)
})

test_that("Test case when using subline_by, page_by, group_by simultaneously with pageby_row = 'first_row' and new_page = TRUE in rtf_body and rtf_subline not null and page_title is 'first' or 'last'", {
  data(r2rtf_adae)
  ae_t3 <- r2rtf_adae[200:260, ] |>
    subset(USUBJID != "01-701-1442") |>
    mutate(
      SUBLINEBY = paste0(
        "Trial Number: ", STUDYID,
        ", Site Number: ", SITEID
      ),
    ) |>
    select(USUBJID, ASTDY, AEDECOD, TRTA, SUBLINEBY) |>
    arrange(SUBLINEBY, TRTA, USUBJID, ASTDY) |>
    rtf_colheader("Subject| Rel Day | Adverse |",
      border_bottom = "single"
    ) |>
    rtf_body(
      subline_by = "SUBLINEBY",
      page_by = c("TRTA"),
      pageby_row = "first_row",
      new_page = TRUE,
      group_by = c("USUBJID", "ASTDY")
    ) |>
    rtf_subline("subline")

  attr(ae_t3, "page")$page_title <- "first"
  ae_t3a <- rtf_encode_table(ae_t3)

  tmp <- lapply(
    strsplit(ae_t3a$body, "\\page", fixed = TRUE)[[1]],
    function(x) grepl("subline", x)
  )
  expect_true(tmp[[1]])

  attr(ae_t3, "page")$page_title <- "last"
  ae_t3b <- rtf_encode_table(ae_t3)

  tmp <- lapply(
    strsplit(ae_t3b$body, "\\page", fixed = TRUE)[[1]],
    function(x) grepl("subline", x)
  )
  expect_true(tmp[[length(tmp)]])
})

tbl <- iris[1, ] |>
  rtf_body() |>
  rtf_title("title")
teststr <- attr(tbl, "rtf_title")

test_that("test if title is converted to RTF correctly", {
  expect_snapshot_output(as_rtf_paragraph(teststr))
})

tbl <- iris[1, ] |>
  rtf_body() |>
  rtf_footnote("footnote")
teststr <- attr(tbl, "rtf_footnote")

test_that("test if footnote is converted to RTF correctly", {
  expect_snapshot_output(as_rtf_paragraph(teststr))
})

tbl <- iris[1, ] |>
  rtf_body() |>
  rtf_source("source")
teststr <- attr(tbl, "rtf_source")

test_that("test if source is converted to RTF correctly", {
  expect_snapshot_output(as_rtf_paragraph(teststr))
})

df <- data.frame(x = 1)
test_that("Test if argument types are checked correctly", {
  expect_error(rtf_page(df, width = c("11")))
  expect_error(rtf_page(df, width = c(11, 8)))
  expect_error(rtf_page(df, height = c("11")))
  expect_error(rtf_page(df, height = c(11, 8)))

  expect_error(rtf_page(df, orientation = 11))
  expect_error(rtf_page(df, orientation = c("a", "b")))

  expect_error(rtf_page(df, margin = c("11")))
  expect_error(rtf_page(df, margin = 1))

  expect_error(rtf_page(df, nrow = c("11")))
  expect_error(rtf_page(df, nrow = c(1, 2)))

  expect_error(rtf_page(df, col_width = c("11")))
  expect_error(rtf_page(df, col_width = c(1, 2)))
})

test_that("Test if function will stop when providing invalid argument values", {
  expect_error(rtf_page(df, width = 0))
  expect_error(rtf_page(df, height = 0))
  expect_error(rtf_page(df, margin = rep(0, 6)))
  expect_error(rtf_page(df, orientation = "ori"))
  expect_error(rtf_page(df, nrow = 0))
  expect_error(rtf_page(df, col_width = 0))
})

test_that("Test if attributes are assigned correctly", {
  df <- rtf_page(df)
  att_df <- attributes(df)

  expect_equal(att_df$page$width, 8.5)
  expect_equal(att_df$page$height, 11)
  expect_equal(att_df$page$margin, set_margin("wma", "portrait"))
  expect_equal(att_df$page$nrow, 40)
  expect_equal(att_df$page$border_first, "double")
  expect_equal(att_df$page$border_last, "double")
  expect_equal(att_df$page$use_color, FALSE)
  expect_equal(att_df$page$col_width, 8.5 - 2.25)

  df <- rtf_page(df, border_color_first = "red")
  att_df <- attributes(df)

  expect_equal(att_df$page$use_color, TRUE)
  expect_equal(att_df$page$border_color_first, "red")
})

test_that("Test if attributes are assigned correctly for orientation not portrait", {
  dfl <- rtf_page(df, orientation = "landscape")
  att_dfl <- attributes(dfl)

  expect_equal(att_dfl$page$width, 11)
  expect_equal(att_dfl$page$height, 8.5)
  expect_equal(att_dfl$page$margin, set_margin("wma", "landscape"))
  expect_equal(att_dfl$page$nrow, 24)
  expect_equal(att_dfl$page$border_first, "double")
  expect_equal(att_dfl$page$border_last, "double")
  expect_equal(att_dfl$page$col_width, 11 - 2.5)
})


test_that("Test when color is used", {
  df <- rtf_page(df, border_color_first = "red")
  att_df <- attr(df, "page")
  expect_true(att_df$use_color)
})

test_that("cell size inch to twip conversion", {
  expect_equal(inch_to_twip(1), 1440)
  expect_equal(inch_to_twip(1.72), round(1.72 * 1440))

  a <- c(20, 50, 40)
  expect_equal(cell_size(a, 20), round(inch_to_twip(20) / sum(a) * a))
})

test_that("UTF-8 to RTF encode conversion", {
  expect_error(utf8Tortf(8))
  expect_equal(utf8Tortf("老人Z"), "\\uc1\\u-32767?\\uc1\\u20154?Z")
})

test_that("input argument checks", {
  expect_error(rtf_title(r2rtf_tbl1, title = 1))
  expect_error(rtf_title(r2rtf_tbl1, subtitle = NA))
  expect_error(rtf_title(r2rtf_tbl1, text_font = "a"))
  expect_error(rtf_title(r2rtf_tbl1, text_font_size = "b"))
  expect_error(rtf_title(r2rtf_tbl1, text_format = "z"))
})

test_that("title format", {
  ## expect NULL if title is NULL
  x <- r2rtf_tbl1 |> rtf_title(title = NULL, subtitle = "Sub-Title", text_format = "b")
  expect_equal(attr(attr(x, "rtf_title"), "title"), NULL)
  expect_equal(attr(x, "rtf_title")[[1]], "Sub-Title")
  expect_equal(attr(attr(x, "rtf_title"), "text_format")[1], "b")

  x <- r2rtf_tbl1 |> rtf_title(title = "Title", subtitle = "Sub-Title", text_format = "b")
  expect_equal(attributes(x)$rtf_title[[1]], "Title")
  expect_equal(attributes(x)$rtf_title[[2]], "Sub-Title")
})

test_that("title font color and background color", {
  x <- r2rtf_tbl1 |> rtf_title(title = "Title", text_color = "green", text_background_color = "blue")
  expect_equal(attr(attr(x, "rtf_title"), "text_color")[1], "green")
  expect_equal(attr(attr(x, "rtf_title"), "text_background_color")[1], "blue")
})

test_that("title justification, spacing and indentation", {
  x <- r2rtf_tbl1 |> rtf_title(
    title = "Title",
    text_justification = "l",
    text_space = 60,
    text_space_before = 6,
    text_space_after = 10,
    text_indent_first = 20,
    text_indent_left = 2,
    text_indent_right = 3
  )
  expect_equal(attr(attr(x, "rtf_title"), "text_justification")[1], "l")
  expect_equal(attr(attr(x, "rtf_title"), "text_space")[1], 60)
  expect_equal(attr(attr(x, "rtf_title"), "text_space_before")[1], 6)
  expect_equal(attr(attr(x, "rtf_title"), "text_space_after")[1], 10)
  expect_equal(attr(attr(x, "rtf_title"), "text_indent_first")[1], 20)
  expect_equal(attr(attr(x, "rtf_title"), "text_indent_left")[1], 2)
  expect_equal(attr(attr(x, "rtf_title"), "text_indent_right")[1], 3)

  expect_error(r2rtf_tbl1 |> rtf_title(justification = "xxx"))
  expect_error(r2rtf_tbl1 |> rtf_title(space = "xxx"))
  expect_error(r2rtf_tbl1 |> rtf_title(indent_first = "xxx"))
})

test_that("multiple subtitles", {
  x <- r2rtf_tbl1 |> rtf_title(title = "Title 1", subtitle = c("Sub-Title 1", "Sub-Title 2", "Sub-Title 3"))
  expect_equal(attributes(x)$rtf_title[[1]], "Title 1")
  expect_equal(attributes(x)$rtf_title[[2]], "Sub-Title 1")
  expect_equal(attributes(x)$rtf_title[[3]], "Sub-Title 2")
  expect_equal(attributes(x)$rtf_title[[4]], "Sub-Title 3")

  x <- r2rtf_tbl1 |> rtf_title(subtitle = c("Sub-Title 1", "Sub-Title 2", "Sub-Title 3"))
  expect_equal(attributes(x)$rtf_title[[1]], "Sub-Title 1")
  expect_equal(attributes(x)$rtf_title[[2]], "Sub-Title 2")
  expect_equal(attributes(x)$rtf_title[[3]], "Sub-Title 3")
})

test_that("case when colheader equals to NULL", {
  x <- r2rtf_tbl1 |> rtf_colheader(colheader = NULL)
  expect_true("data.frame" %in% class(x))

  y <- rtf_colheader(r2rtf_tbl1, colheader = NULL)
  expect_equal(attributes(y)$colheader, NULL)

  z <- r2rtf_tbl1 |> rtf_colheader(colheader = NULL, border_color_left = "green")
  expect_equal(attributes(z)$colheader, NULL)
  expect_equal(attributes(z)$border_color_left, NULL)

  u <- r2rtf_tbl1 |> rtf_colheader(colheader = " | | ")
  expect_equal(data.frame(attributes(u)$rtf_colheader[[1]]), data.frame(data.frame(X1 = "", X2 = "", X3 = "")))
})

test_that("multiple colheaders separated by |", {
  x <- rtf_colheader(r2rtf_tbl1, "a | b | c")
  expect_equal(data.frame(attributes(x)$rtf_colheader[[1]]), data.frame(X1 = "a", X2 = "b", X3 = "c"))
})

test_that("border color", {
  x <- r2rtf_tbl1 |>
    rtf_body() |>
    rtf_colheader(colheader = " a | b | c ", border_color_left = "green")
  xx <- r2rtf_tbl1 |>
    rtf_body() |>
    rtf_colheader(colheader = " a | b | c ", border_color_left = c("red", "green", "blue"))
  y <- r2rtf_tbl1 |>
    rtf_body() |>
    rtf_colheader(colheader = "  | b |   ", border_color_right = c("red", "green", "blue"))
  z <- r2rtf_tbl1 |>
    rtf_body() |>
    rtf_colheader(colheader = " a |   |c  ", border_color_top = c("blue", "green", "blue"))
  u <- r2rtf_tbl1 |>
    rtf_body() |>
    rtf_colheader(colheader = " a | b | c ", border_color_bottom = "yellow")

  expect_equal(attr(attr(x, "rtf_colheader")[[2]], "border_color_left")[1, ], c("green", "green", "green"))
  expect_equal(attr(attr(xx, "rtf_colheader")[[2]], "border_color_left")[1, ], c("red", "green", "blue"))
  expect_equal(attr(attr(y, "rtf_colheader")[[2]], "border_color_right")[1, ], c("red", "green", "blue"))
  expect_equal(attr(attr(z, "rtf_colheader")[[2]], "border_color_top")[1, ], c("blue", "green", "blue"))
  expect_equal(attr(attr(u, "rtf_colheader")[[2]], "border_color_bottom")[1, ], c("yellow", "yellow", "yellow"))
})

test_that("border type", {
  x <- r2rtf_tbl1 |>
    rtf_body() |>
    rtf_colheader(colheader = " a | b | c ", border_left = c("double", "single", "dot dot"))
  expect_equal(attr(attr(x, "rtf_colheader")[[2]], "border_left")[1, ], c("double", "single", "dot dot"))
})


test_that("cell text formats", {
  x <- r2rtf_tbl1 |>
    rtf_body() |>
    rtf_colheader(colheader = " a | b | c ", text_format = c("u", "i", "s"))

  expect_error(rtf_colheader(r2rtf_tbl1, colheader = " a | b | c ", text_format = c("$20.", "$5.", "$20.")))
  expect_error(rtf_colheader(r2rtf_tbl1, colheader = " a | b | c ", text_format = "%m/%d/%Y"))
  expect_error(rtf_colheader(r2rtf_tbl1, colheader = " a | b | c ", text_format = c("a", "b", "c")))
  expect_equal(attr(attr(x, "rtf_colheader")[[2]], "text_format")[1, ], c("u", "i", "s"))
})

test_that("Check argument type, test if error message will show correctly", {
  expect_error(
    obj_rtf_text(text = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_font = "1"),
    "The argument type did not match: integer/numeric"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_format = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_font_size = "1"),
    "The argument type did not match: integer/numeric"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_color = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_background_color = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_justification = 1),
    "The argument type did not match: character"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_space_before = "1"),
    "The argument type did not match: integer/numeric"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_space_after = "1"),
    "The argument type did not match: integer/numeric"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_new_page = "1"),
    "The argument type did not match: logical"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_hyphenation = "1"),
    "The argument type did not match: logical"
  )
  expect_error(
    obj_rtf_text(text = "testing", text_convert = "1"),
    "The argument type did not match: logical"
  )
})

test_that("Check argument values, test if error message will show correctly", {
  expect_error(obj_rtf_text(text = "testing", text_font = 20), )
  expect_error(obj_rtf_text(text = "testing", text_format = "aa"), )
  expect_error(obj_rtf_text(text = "testing", text_font_size = -1), )
  expect_error(obj_rtf_text(text = "testing", text_color = "redd"), )
  expect_error(obj_rtf_text(text = "testing", text_background_color = "redd"), )
  expect_error(obj_rtf_text(text = "testing", text_justification = "left"), )
  # expect_error(obj_rtf_text(text="testing",text_space_before = -1),)
  # expect_error(obj_rtf_text(text="testing",text_space_after = -1),)
  # expect_error(obj_rtf_text(text="testing",text_new_page = "1"),)
  # expect_error(obj_rtf_text(text="testing",text_hyphenation = "1"),)
  # expect_error(obj_rtf_text(text="testing",text_convert = "1"),)
  #
})

test_that("Test if attributes are assigned correctly", {
  a <- obj_rtf_text(
    text = "testing",
    text_font = 1,
    text_format = "b",
    text_font_size = 16,
    text_color = "red",
    text_background_color = "red",
    text_justification = "l",
    text_indent_first = 0,
    text_indent_left = 0,
    text_indent_right = 0,
    text_space = 1,
    text_space_before = 15,
    text_space_after = 15,
    text_new_page = FALSE,
    text_hyphenation = TRUE,
    text_convert = TRUE
  )
  expect_equal(attr(a, "text_font")[1], 1)
  expect_equal(attr(a, "text_format")[1], "b")
  expect_equal(attr(a, "text_font_size")[1], 16)
  expect_equal(attr(a, "text_color")[1], "red")
  expect_equal(attr(a, "text_background_color")[1], "red")
  expect_equal(attr(a, "text_justification")[1], "l")
  expect_equal(attr(a, "text_indent_first")[1], 0)
  expect_equal(attr(a, "text_indent_left")[1], 0)
  expect_equal(attr(a, "text_indent_right")[1], 0)
  expect_equal(attr(a, "text_space")[1], 1)
  expect_equal(attr(a, "text_space_before")[1], 15)
  expect_equal(attr(a, "text_space_after")[1], 15)
  expect_equal(attr(a, "text_new_page")[1], FALSE)
  expect_equal(attr(a, "text_hyphenation")[1], TRUE)
  expect_equal(attr(a, "text_convert")[1], TRUE)
})

test_that("Test if color_used is derived correctly", {
  a <- obj_rtf_text(
    text = "testing",
    text_font = 1,
    text_format = "b",
    text_font_size = 16,
    text_color = "red",
    text_background_color = "red",
    text_justification = "l",
    text_indent_first = 0,
    text_indent_left = 0,
    text_indent_right = 0,
    text_space = 1,
    text_space_before = 15,
    text_space_after = 15,
    text_new_page = FALSE,
    text_hyphenation = TRUE,
    text_convert = TRUE
  )
  expect_equal(attr(a, "use_color")[1], TRUE)

  a <- obj_rtf_text(
    text = "testing",
    text_font = 1,
    text_format = "b",
    text_font_size = 16,
    text_color = "black",
    text_background_color = "black",
    text_justification = "l",
    text_indent_first = 0,
    text_indent_left = 0,
    text_indent_right = 0,
    text_space = 1,
    text_space_before = 15,
    text_space_after = 15,
    text_new_page = FALSE,
    text_hyphenation = TRUE,
    text_convert = TRUE
  )
  expect_equal(attr(a, "use_color")[1], FALSE)
})

test_that("Test when input is a data frame", {
  a <- obj_rtf_text(
    text = iris[1:2, ],
    text_font = 1,
    text_format = "b"
  )
  expect_equal(attr(a, "text_font"), matrix(data = rep(1, 10), nrow = 2))
  expect_equal(attr(a, "text_format"), matrix(data = rep("b", 10), nrow = 2))
})

test_that("read in PNG file in binary format", {
  df <- c("fig/fig1.png", "fig/fig2.png")
  png_vec_in <- rtf_read_figure(df)

  png_in_1 <- readBin(df[1], what = "raw", size = 1, signed = TRUE, endian = "little", n = 1e8)
  png_in_2 <- readBin(df[2], what = "raw", size = 1, signed = TRUE, endian = "little", n = 1e8)

  png_lst <- list(png_in_1, png_in_2)
  attr(png_vec_in, "fig_format") <- NULL

  expect_equal(png_vec_in, png_lst)
})

test_that("Test case when footnote and source display in all pages", {
  m1 <- iris[1:2, ] |>
    rtf_body(as_colheader = TRUE, border_color_left = "red") |>
    rtf_title("title") |>
    rtf_source("source")
  m2 <- iris[3:4, ] |>
    rtf_body(as_colheader = TRUE)
  m3 <- iris[5:6, ] |>
    rtf_body(as_colheader = TRUE)
  m <- list(m1, m2, m3)

  attr(m1, "page")$page_title <- "all"
  attr(m1, "page")$page_footnote <- "all"
  attr(m1, "page")$page_source <- "all"

  attr(m2, "page")$page_title <- "all"
  attr(m2, "page")$page_footnote <- "all"
  attr(m2, "page")$page_source <- "all"

  attr(m3, "page")$page_title <- "all"
  attr(m3, "page")$page_footnote <- "all"
  attr(m3, "page")$page_source <- "all"

  m_out <- m |>
    rtf_encode_list()

  expect_snapshot_output(m_out)
})

test_that("Test case when page width, height, or orientation are not consistent", {
  m1 <- iris[1:2, ] |>
    rtf_body()

  m2 <- iris[3:4, ] |>
    rtf_page(width = 9) |>
    rtf_body()

  m3 <- iris[3:4, ] |>
    rtf_page(height = 10) |>
    rtf_body()

  m4 <- iris[3:4, ] |>
    rtf_page(orientation = "landscape") |>
    rtf_body()

  width_diff <- list(m1, m2)
  height_diff <- list(m1, m3)
  orientation_diff <- list(m1, m4)

  expect_error(rtf_encode_list(width_diff))
  expect_error(rtf_encode_list(height_diff))
  expect_error(rtf_encode_list(orientation_diff))
})


test_that("Test case when footnote location or source location are not consistent, page_footnote or page_source != 'last', length of list == 1", {
  m1 <- iris[1:2, ] |>
    rtf_footnote("footer 1") |>
    rtf_body()

  attr(m1, "page")$page_footnote <- "all"

  m2 <- iris[3:4, ] |>
    rtf_body()

  m3 <- iris[3:4, ] |>
    rtf_source("source") |>
    rtf_body()

  attr(m3, "page")$page_source <- "all"

  m4 <- iris[3:4, ] |>
    rtf_body()

  attr(m4, "page")$page_footnote <- "all"

  m5 <- iris[3:4, ] |>
    rtf_source("source") |>
    rtf_body()

  attr(m5, "page")$page_source <- "all"

  footnote_diff <- list(m1, m2)
  source_diff <- list(m2, m3)
  footnote_all <- list(m1, m4)
  source_all <- list(m3, m5)
  onelist <- list(m2)

  expect_error(rtf_encode_list(footnote_diff))
  expect_error(rtf_encode_list(source_diff))
  expect_error(rtf_encode_list(footnote_all))
  expect_error(rtf_encode_list(source_all))
  expect_error(rtf_encode_list(onelist))
})


test_that("Test case when having multiple footnotes or sources", {
  m1 <- iris[1:2, ] |>
    rtf_footnote("footer 1") |>
    rtf_source("source 1") |>
    rtf_body()

  m2 <- iris[3:4, ] |>
    rtf_footnote("footer 2") |>
    rtf_body()

  m3 <- iris[3:4, ] |>
    rtf_source("source 2") |>
    rtf_body()

  footnote_multi <- list(m1, m2)
  source_multi <- list(m1, m3)

  expect_message(rtf_encode_list(footnote_multi), "Only rtf_footnote in first item is used")
  expect_message(rtf_encode_list(source_multi), "Only rtf_source in first item is used")
})


test_that("Test nrow is consistent with first list", {
  m1 <- iris |>
    rtf_body()

  m2 <- iris |>
    rtf_page(
      nrow = 10,
      border_color_first = "red",
      border_color_last = "red"
    ) |>
    rtf_body()

  m3 <- iris |>
    rtf_body()

  tbl <- list(m1, m2, m3)

  n <- length(tbl)

  tbl[2:n] <- lapply(tbl[2:n], function(x) {
    attr(x, "page")$nrow <- attr(tbl[[1]], "page")$nrow
    x
  })

  attr(tbl[[2]], "page")$border_color_first

  expect_equal(attr(tbl[[2]], "page")$nrow, 40)

  m1 <- iris |>
    rtf_body()

  m2 <- iris |>
    rtf_page(
      nrow = 10,
      border_color_first = "red",
      border_color_last = "red"
    ) |>
    rtf_body()

  m3 <- iris |>
    rtf_body()

  tbl <- list(m1, m2, m3)

  n <- length(tbl)

  tbl[2:(n - 1)] <- lapply(tbl[2:(n - 1)], function(x) {
    attr(x, "page")$border_first <- NULL
    attr(x, "page")$border_last <- NULL
    attr(x, "page")$border_color_first <- NULL
    attr(x, "page")$border_color_last <- NULL
    x
  })

  expect_equal(attr(tbl[[2]], "page")$border_first, NULL)
  expect_equal(attr(tbl[[2]], "page")$border_last, NULL)
  expect_equal(attr(tbl[[2]], "page")$border_color_first, NULL)
  expect_equal(attr(tbl[[2]], "page")$border_color_last, NULL)
})


test_that("Test border_color_first, border_color_last, border_first, and nrow", {
  m1 <- iris[1:15, ] |>
    rtf_page(
      nrow = 5,
      border_color_first = "red"
    ) |>
    rtf_body()

  m2 <- iris[31:50, ] |>
    rtf_page(
      border_first = "double",
      border_last = "double"
    ) |>
    rtf_body()

  m3 <- iris[51:60, ] |>
    rtf_page(border_color_last = "red") |>
    rtf_body()

  tbl <- list(m1, m2, m3)

  tbl_out <- tbl |>
    rtf_encode_list()

  expect_snapshot_output(tbl_out)
})

test_that("Test when orientation are different in the list", {
  m1 <- iris[1:15, ] |>
    rtf_page(
      nrow = 5,
      border_color_first = "red", orientation = "landscape"
    ) |>
    rtf_body()

  m2 <- iris[31:50, ] |>
    rtf_page(
      border_first = "double",
      border_last = "double"
    ) |>
    rtf_body()

  m3 <- iris[51:60, ] |>
    rtf_page(border_color_last = "red") |>
    rtf_body()

  tbl <- list(m1, m2, m3)

  expect_error(tbl_out <- tbl |> rtf_encode_list())
})

test_that("Test case to split page", {
  m1 <- iris[1:31, ] |>
    rtf_page(
      nrow = 4,
    ) |>
    rtf_body()

  m2 <- iris[40:50, ] |>
    rtf_body()

  tbl <- list(m1, m2)

  tbl |>
    rtf_encode_list() |>
    expect_snapshot_output()
})

test_that("Input check for arguments", {
  # check each arguments with different input type
  expect_error(rtf_subset(c("a", "b"), row = 1, col = 1))
  expect_error(rtf_subset(matrix(1:9, nrow = 3, ncol = 3), row = 1:2, col = c(1:2)))
  expect_error(rtf_subset(r2rtf_tbl1, row = "1", col = c(1:2)))
})


# an example of data frame with attributes
tbl <- r2rtf_tbl1 |>
  rtf_colheader(colheader = "Trt|N1|Mean1|N2|Mean2|N3|Mean3|CI", border_left = "") |>
  rtf_body(col_rel_width = c(1, 2, 3, 4, 2, 2, 2, 2))

# an example of subsetted data frame
tbl_sub <- tbl |> rtf_subset(row = 1:2, col = 2:4)

# create two expected matrices
blk <- matrix("", nrow = 2, ncol = 3)
sgl <- matrix("single", nrow = 2, ncol = 3)


test_that("Test whether border/text attributes were passed correctly", {
  expect_equal(attr(tbl_sub, "border_top"), blk)
  expect_equal(attr(tbl_sub, "border_left"), sgl)
  expect_equal(attr(tbl_sub, "border_right"), sgl)
  expect_equal(attr(tbl_sub, "border_bottom"), blk)
  expect_equal(attr(tbl_sub, "border_first"), sgl)
  expect_equal(attr(tbl_sub, "border_last"), sgl)
  expect_equal(attr(tbl_sub, "border_color_left"), NULL)
  expect_equal(attr(tbl_sub, "border_color_right"), NULL)
  expect_equal(attr(tbl_sub, "border_color_first"), NULL)
  expect_equal(attr(tbl_sub, "text_font"), matrix(1, nrow = 2, ncol = 3))
  expect_equal(attr(tbl_sub, "text_format"), NULL)
  expect_equal(attr(tbl_sub, "text_font_size"), matrix(9, nrow = 2, ncol = 3))
  expect_equal(attr(tbl_sub, "text_justification"), matrix("c", nrow = 2, ncol = 3))
  expect_equal(attr(tbl_sub, "text_convert"), matrix(TRUE, nrow = 2, ncol = 3))
  expect_equal(attr(tbl_sub, "cell_nrow"), NULL)
})


test_that("Test whether scale attributes were passed correctly", {
  expect_equal(attr(tbl_sub, "border_width"), 15)
  expect_equal(attr(tbl_sub, "cell_height"), .15)
  expect_equal(attr(tbl_sub, "text_space_before"), 15)
  expect_equal(attr(tbl_sub, "text_space_after"), 15)
  expect_equal(attr(tbl_sub, "cell_justification"), "c")
})


test_that("Test whether other attributes were passed correctly", {
  expect_equal(attr(tbl_sub, "rtf_pageby")["new_page"], list(new_page = FALSE))
  expect_true(is.null(attr(tbl_sub, "rtf_pageby$by_var")))
  expect_true(is.null(attr(tbl_sub, "rtf_pageby$id")))
  expect_true(attr(tbl_sub, "last_row"))
  expect_true(attr(tbl_sub, "text_hyphenation"))
  expect_false(attr(tbl_sub, "use_color"))
  expect_false(attr(tbl_sub, "text_new_page"))
  expect_equal(attr(tbl_sub, "col_rel_width"), c(2, 3, 4))
  expect_equal(attr(tbl_sub, "text_indent_first"), matrix(0, nrow = 2, ncol = 3))
  expect_equal(attr(tbl_sub, "page")["use_color"], list(use_color = FALSE))
  expect_equal(attr(tbl_sub, "page")["border_last"], list(border_last = "double"))
  expect_equal(attr(tbl_sub, "page")["col_width"], list(col_width = 6.25))
  expect_equal(attr(tbl_sub, "page")["nrow"], list(nrow = 40))
  expect_equal(attr(tbl_sub, "page")["margin"], list(margin = c(1.25, 1, 1.75, 1.25, 1.75, 1.00625)))
  expect_equal(attr(tbl_sub, "page")["orientation"], list(orientation = "portrait"))
  expect_equal(attr(tbl_sub, "page")["height"], list(height = 11))
  expect_equal(attr(tbl_sub, "names"), c("N1", "Mean1", "N2"))
  expect_equal(attr(tbl_sub, "class"), c("data.frame", "rtf_text", "rtf_border"))
  expect_equal(attr(tbl_sub, "row.names"), c(1, 2))
})

---
title: "An Introduction to the r2rtf Package"
output:
  rmarkdown::html_vignette:
    number_sections: yes
    toc: yes
vignette: >
  %\VignetteIndexEntry{An Introduction to the r2rtf Package}
  %\VignetteEngine{knitr::rmarkdown}
---

Please see <https://merck.github.io/r2rtf/articles/index.html> for the full documentation. Here is only a minimal example:

```{r, eval = FALSE}
library(dplyr)
library(r2rtf)

head(iris) %>%
  rtf_body() %>% # Step 1 Add attributes
  rtf_encode() %>% # Step 2 Convert attributes to RTF encode
  write_rtf(file = "ex-tbl.rtf") # Step 3 Write to a .rtf file
```
